define({"376":{y:0,u:"../users-guide/detecting-network-co.htm",l:-1,t:"Detecting Network Connection Failure Parameters",i:0.000227983329142783,a:"Detecting Network Connection Failure Parameters This feature lets servers and clients detect network connection failures quickly. When these parameters are absent, or this feature is disabled, \n\t tibemsd closes a connection only upon the operating system notification.\n  "},"377":{y:0,u:"../users-guide/active-route-connect.htm",l:-1,t:"active_route_connect_time",i:0.000262088090307263,a:"active_route_connect_time Specifies the interval (in seconds) at which an EMS server attempts to connect or reconnect a route to the another server. The default is 2 seconds.\n\t  active_route_connect_time = interval"},"378":{y:0,u:"../users-guide/client-heartbeat-ser.htm",l:-1,t:"client_heartbeat_server",i:0.000262088090307263,a:"In a server-to-client connection, clients send heartbeats to the server at this interval (in seconds).\n\t  client_heartbeat_server = interval The \n\t\t  client_heartbeat_server parameter must be specified when a \n\t\t   server_timeout_client_connection is set.  The \n\t\t  client_heartbeat_server interval ..."},"379":{y:0,u:"../users-guide/clock-sync-interval.htm",l:-1,t:"clock_sync_interval",i:0.000464056288162633,a:"Periodically send the EMS server’s Coordinated Universal Time (UTC) time to clients. This allows EMS clients to update their offset. \n\t  clock_sync_interval = seconds The time specified, in seconds, determines the interval at which clock sync commands are sent from the server to its clients. \n\t\t ..."},"380":{y:0,u:"../users-guide/server-timeout-clien.htm",l:-1,t:"server_timeout_client_connection",i:0.000262088090307263,a:"In a server-to-client connection, if the server does not receive a heartbeat for a period exceeding this limit (in seconds), it closes the connection.\n\t  server_timeout_client_connection = limit We recommend setting this value to approximately 3 times the heartbeat interval, as it is specified in ..."},"381":{y:0,u:"../users-guide/server-heartbeat-ser.htm",l:-1,t:"server_heartbeat_server",i:0.000262088090307263,a:"In a server-to-server connection, this server sends heartbeats at this interval (in seconds). The two servers can be connected either by a route, or as a fault-tolerant pair.\n\t  server_heartbeat_server = interval When using FTL stores, this parameter only affects server-to-server route connections. ..."},"382":{y:0,u:"../users-guide/server-timeout-serve.htm",l:-1,t:"server_timeout_server_connection",i:0.00174277208653661,a:"In a server-to-server connection, if this server does not receive a heartbeat for a period exceeding this limit (in seconds), it closes the connection. This parameter applies to connections from other routes and to the standby server connection.\n\t  server_timeout_server_connection = limit We ..."},"383":{y:0,u:"../users-guide/server-heartbeat-cli.htm",l:-1,t:"server_heartbeat_client",i:0.000262088090307263,a:"server_heartbeat_client In a server-to-client connection, the server sends heartbeats to all clients at this interval (in seconds).\n\t  server_heartbeat_client = interval When omitted or zero, the default is 5 seconds.\n\t\t"},"384":{y:0,u:"../users-guide/client-timeout-serve.htm",l:-1,t:"client_timeout_server_connection",i:0.000262088090307263,a:"In a server-to-client connection, if a client does not receive a heartbeat for a period exceeding this limit (in seconds), it closes the connection.\n\t  client_timeout_server_connection = limit We recommend setting this value to approximately 3.5 times the heartbeat interval.\n\t\t Zero is a special ..."},"385":{y:0,u:"../users-guide/fault-tolerance-para.htm",l:-1,t:"Fault Tolerance Parameters",i:0.000536432456027917,a:"See \n\t\t Fault Tolerance  for more information about these parameters. \n\t  The fault tolerance parameters that begin with the prefix \n\t\tft_ssl \n\t\tare used to secure communications between pairs of fault tolerant servers. See \n\t\t TLS for additional information about this process.  Aside from ..."},"386":{y:0,u:"../users-guide/ft-active.htm",l:-1,t:"ft_active",i:0.00032668431306076,a:"ft_active Specifies the URL of the active server. If this server can connect to the active server, it will act as a standby server. If this server cannot connect to the active server, it will become the active server.\n\t  ft_active = URL"},"387":{y:0,u:"../users-guide/ft-heartbeat.htm",l:-1,t:"ft_heartbeat",i:0.000262088090307263,a:"ft_heartbeat Specifies the interval (in seconds) the server is to send a heartbeat signal to its peer to indicate that it is still operating.\n\t  ft_heartbeat = seconds Default is 3 seconds.\n\t\t"},"388":{y:0,u:"../users-guide/ft-activation.htm",l:-1,t:"ft_activation",i:0.00174277208653661,a:"Activation interval (maximum length of time between heartbeat signals) which indicates that server has failed.\n\t  ft_activation = seconds Set in seconds: default is 10. This interval should be set to at least twice the heartbeat interval.\n\t\t For example:\n\t\t ft_activation = 60 See the \n\t\t   ..."},"389":{y:0,u:"../users-guide/ft-reconnect-timeout.htm",l:-1,t:"ft_reconnect_timeout",i:0.00303119746169856,a:"The amount of time (in seconds) that a standby server waits for clients to reconnect (after it becomes the active server in a failover situation).\n\t  ft_reconnect_timeout = seconds If a client does not reconnect within this time period, the server removes its state from the shared state files. The ..."},"390":{y:0,u:"../users-guide/ft-ssl-identity.htm",l:-1,t:"ft_ssl_identity",i:0.000262088090307263,a:"The path to a file that contains the certificate in one of the supported formats. The supported formats are PEM, DER, or PKCS#12. A DER format file can only contain the certificate; it cannot contain both the certificate and a private key. \n\t  ft_ssl_identity = pathname See \n\t\t   File Names for ..."},"391":{y:0,u:"../users-guide/ft-ssl-issuer.htm",l:-1,t:"ft_ssl_issuer",i:0.000262088090307263,a:"Certificate chain member for the server. Supply the entire chain, including the CA root certificate. The server reads the certificates in the chain in the order they are presented in this parameter. \n\t  ft_ssl_issuer = chain_member The certificates must be in PEM, DER, PKCS#7, or PKCS#12 format. A ..."},"392":{y:0,u:"../users-guide/ft-ssl-private-key.htm",l:-1,t:"ft_ssl_private_key",i:0.000262088090307263,a:"The server’s private key. If it is included in the digital certificate in \n\t ft_ssl_identity, then this parameter is not needed.\n\t  ft_ssl_private_key = key This parameter supports private keys in the following formats: PEM, DER, PKCS#12.\n\t\t You can specify the actual key in this parameter, or you ..."},"393":{y:0,u:"../users-guide/ft-ssl-password.htm",l:-1,t:"ft_ssl_password",i:0.000262088090307263,a:"Private key or password for private keys. \n\t  ft_ssl_password = password You can set passwords by way of the \n\t\t  tibemsadmin tool. When passwords are set with this tool, the password is obfuscated in the configuration file. See \n\t\t   EMS Administration Tool  for more information about using \n\t\t  ..."},"394":{y:0,u:"../users-guide/ft-ssl-trusted.htm",l:-1,t:"ft_ssl_trusted",i:0.000262088090307263,a:"List of trusted certificates. This sets which Certificate Authority certificates should be trusted as issuers of the client certificates. \n\t  ft_ssl_trusted = trusted_certificates The certificates must be in PEM, DER, or PKCS#7 format. You can either provide the actual certificates, or you can ..."},"395":{y:0,u:"../users-guide/ft-ssl-verify-host.htm",l:-1,t:"ft_ssl_verify_host",i:0.000262088090307263,a:"Specifies whether the fault-tolerant server should verify the other server’s certificate. \n   ft_ssl_verify_host = enabled | disabled The values for this parameter are \n\t\t   enabled or \n\t\t   disabled. \n\t\t By default, this parameter is \n\t\t  enabled, signifying the server should verify the other ..."},"396":{y:0,u:"../users-guide/ft-ssl-verify-hostna.htm",l:-1,t:"ft_ssl_verify_hostname",i:0.000262088090307263,a:"Specifies whether the fault-tolerant server should verify the name in the CN field of the other server’s certificate. \n\t  ft_ssl_verify_hostname = enabled | disabled The values for this parameter are \n\t\t   enabled and \n\t\t   disabled. By default, this parameter is enabled, signifying the ..."},"397":{y:0,u:"../users-guide/ft-ssl-expected-host.htm",l:-1,t:"ft_ssl_expected_hostname",i:0.000262088090307263,a:"Specifies the name the server is expected to have in the CN field of the fault-tolerant server’s certificate.\n\t  ft_ssl_expected_hostname = serverName If this parameter is not set, the expected name is the hostname of the server.\n\t\t This parameter is used when the \n\t\t  ft_ssl_verify_hostname ..."},"398":{y:0,u:"../users-guide/ft-ssl-ciphers.htm",l:-1,t:"ft_ssl_ciphers",i:0.000300845823959361,a:"Specifies the cipher suites used by the server; each suite in the list is separated by a colon (:). This parameter can use the OpenSSL name for cipher suites or the longer, more descriptive names.\n\t  ft_ssl_ciphers = cipherSuite See \n\t\t   Specify Cipher Suites  for more information about the cipher ..."},"399":{y:0,u:"../users-guide/ft_oauth2_access_token_file.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_access_token_file Specifies the path to a file containing an OAuth 2.0 access token to use to authenticate with the fault-tolerant peer EMS server.  ft_oauth2_access_token_file = pathname If an access token is provided using this parameter, the EMS server will not attempt to obtain access ..."},"400":{y:0,u:"../users-guide/ft_oauth2_server_url.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_server_url Specifies the HTTP or HTTPS URL of the OAuth 2.0 authorization server from which the EMS server will obtain access tokens for authenticating with its fault-tolerant peer EMS server. ft_oauth2_server_url = http://hostname:port If connecting to a secure OAuth 2.0 authorization ..."},"401":{y:0,u:"../users-guide/ft_oauth2_client_id.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_client_id The OAuth 2.0 client ID to use when authenticating with the OAuth 2.0 authorization server. This parameter and ft_oauth2_client_secret are both required in order to obtain access tokens from the authorization server, regardless of the grant type to be used.\t  ft_oauth2_client_id ..."},"402":{y:0,u:"../users-guide/ft_oauth2_client_secret.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_client_secret The OAuth 2.0 client secret to use when authenticating with the OAuth 2.0 authorization server. This parameter and ft_oauth2_client_id are both required in order to obtain access tokens from the authorization server, regardless of the configured grant type. ..."},"403":{y:0,u:"../users-guide/ft_oauth2_grant_type.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_grant_type The grant type to use for requesting access tokens from the OAuth 2.0 authorization server. The accepted values are: client_credentials–for  Client Credentials  grant. password–for  Resource Owner Password Credentials  grant. ft_oauth2_grant_type = client_credentials|password If ..."},"404":{y:0,u:"../users-guide/ft_oauth2_server_trust_file.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_server_trust_file Specifies the path to a file containing one or more PEM-encoded public certificates that can be used to validate a secure OAuth 2.0 authorization server\u0027s identity.\t  ft_oauth2_server_trust_file = trust_file This parameter is only required if an HTTPS URL was specified ..."},"405":{y:0,u:"../users-guide/ft_oauth2_disable_verify_hostname.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_disable_verify_hostname When this parameter is enabled, the EMS server will not verify the hostname in the CN field of the OAuth 2.0 authorization server’s certificate. ft_oauth2_disable_verify_hostname = enabled|disabled This parameter is disabled by default."},"406":{y:0,u:"../users-guide/ft_oauth2_expected_hostname.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ft_oauth2_expected_hostname The name that the EMS server expects in the CN field of the OAuth 2.0 authorization server’s certificate.\n\t  ft_oauth2_expected_hostname = hostname If this parameter is not set, the expected name is the hostname of the authorization server. This parameter is not relevant ..."},"407":{y:0,u:"../users-guide/message-tracking-par.htm",l:-1,t:"Message Tracking Parameters",i:0.000227983329142783,a:"Message Tracking Parameters The parameters described in the following topics configure the message tracking behavior of the EMS server. \n  "},"408":{y:0,u:"../users-guide/track-message-ids.htm",l:-1,t:"track_message_ids",i:0.000455876758567754,a:"track_message_ids Tracks messages by message ID. Default is disabled. \n   track_message_ids = enabled | disabled Enabling this parameter allows you to display messages using the \n\t\t  show messagemessageID command in the administration tool. \n\t\t"},"409":{y:0,u:"../users-guide/track-correlation-id.htm",l:-1,t:"track_correlation_ids",i:0.000262088090307263,a:"track_correlation_ids Tracks messages by correlation ID. Disabled by default. \n   track_correlation_ids = enabled | disabled Enabling this parameter allows you to display messages using the \n\t\t  show messagescorrelationID command in the administration tool. \n\t\t"},"410":{y:0,u:"../users-guide/tibco-ftl-transport-.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000297962570459072,a:"The parameters listed here enable the EMS server to connect to a TIBCO FTL server using transports configured in the \n\t\t transports.conf file. \n\t  \n            The EMS server creates a single FTL event queue that is used for all EMS transports for FTL configured in the \n\t\ttransports.conf file. \n\t  ..."},"411":{y:0,u:"../users-guide/ftl-log-level.htm",l:-1,t:"ftl_log_level",i:0.000262088090307263,a:"ftl_log_level Optional. Determines the trace level of FTL messages logged in the server when the EMS Server FTL trace item is enabled. \n   ftl_log_level = level When absent, the \n\t\t  ftl_log_level defaults to \n\t\t  warn. \n\t\t For more details, see the TIBCO FTL documentation on logging. \n\t\t"},"412":{y:0,u:"../users-guide/ftl-trustfile.htm",l:-1,t:"ftl_trustfile",i:0.000283620164558429,a:"Optional. Specifies the trust file for the EMS server to validate the FTL server on a TLS connection. \n   ftl_trustfile = file name The trust file must be the same as that used by other FTL clients to validate the FTL server. \n\t\t    For the trust file to be used, the \n\t\t\t ftl_url must start with ..."},"413":{y:0,u:"../users-guide/ftl-url.htm",l:-1,t:"ftl_url",i:0.000283620164558429,a:"ftl_url Required. Specifies the URL at which the EMS server can connect to the TIBCO FTL server. \n   ftl_url = URL For example, \n\t\t  ftl_url=http://localhost:5633. \n\t\t For more details, see the TIBCO FTL documentation on realms. \n\t\t"},"414":{y:0,u:"../users-guide/ftl-username.htm",l:-1,t:"ftl_username",i:0.00048486688383216,a:"Optional. The username that the EMS server should use to authenticate itself when connecting to the TIBCO FTL server. \n   ftl_username = user Sets the \n\t\t  com.tibco.ftl.client.username property. For more details, see the TIBCO FTL documentation on realms.  When authenticating with FTL using OAuth ..."},"415":{y:0,u:"../users-guide/ftl-password.htm",l:-1,t:"ftl_password",i:0.000262088090307263,a:"Optional. The password that the EMS server should use to authenticate itself when connecting to the TIBCO FTL server. Note that the password can be stored in a mangled form. \n   ftl_password = password Sets the \n\t\t  com.tibco.ftl.client.userpassword property. For more details, see the TIBCO FTL ..."},"416":{y:0,u:"../users-guide/ftl_oauth2_access_token_file.htm",l:-1,t:"ftl_password",i:0.000262088090307263,a:"ftl_oauth2_access_token_file Specifies the path to a file containing an OAuth 2.0 access token to use to authenticate with the FTL deployment. \n   ftl_oauth2_access_token_file = pathname If an access token is provided via this parameter, the EMS server will always use that access token for ..."},"417":{y:0,u:"../users-guide/ftl_oauth2_server_url.htm",l:-1,t:"ft_ssl_ciphers",i:0.000283620164558429,a:"ftl_oauth2_server_url Specifies the HTTP or HTTPS URL of the OAuth 2.0 authorization server from which the EMS server will obtain access tokens for authenticating with the FTL deployment.\t  ftl_oauth2_server_url = http://hostname:port If connecting to a secure OAuth 2.0 authorization server: ..."},"418":{y:0,u:"../users-guide/ftl_oauth2_client_id.htm",l:-1,t:"ft_ssl_ciphers",i:0.000283620164558429,a:"ftl_oauth2_client_id The OAuth 2.0 client ID to use when authenticating with the OAuth 2.0 authorization server. This parameter and ftl_oauth2_client_secret are both required in order to obtain access tokens from the authorization server, regardless of the configured grant type. ftl_oauth2_client_id ..."},"419":{y:0,u:"../users-guide/ftl_oauth2_client_secret.htm",l:-1,t:"ft_ssl_ciphers",i:0.000283620164558429,a:"ftl_oauth2_client_secret The OAuth 2.0 client secret to use when authenticating with the OAuth 2.0 authorization server. This parameter and ftl_oauth2_client_id are both required in order to obtain access tokens from the authorization server, regardless of the grant type to be used.\t  ..."},"420":{y:0,u:"../users-guide/ftl_oauth2_server_trust_file.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ftl_oauth2_server_trust_file Specifies the path to a file containing one or more PEM-encoded public certificates for validating a secure OAuth 2.0 authorization server\u0027s identity.\t  ftl_oauth2_server_trust_file = trust_file This parameter is only required if an HTTPS URL was specified for ..."},"421":{y:0,u:"../users-guide/ftl_oauth2_disable_verify_hostname.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ftl_oauth2_disable_verify_hostname When this parameter is enabled, the EMS server will not verify the hostname in the CN field of the OAuth 2.0 authorization server’s certificate. ftl_oauth2_disable_verify_hostname = enabled|disabled This parameter is disabled by default."},"422":{y:0,u:"../users-guide/ftl_oauth2_expected_hostname.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"ftl_oauth2_expected_hostname The name that the EMS server expects in the CN field of the OAuth 2.0 authorization server’s certificate.\n\t  ftl_oauth2_expected_hostname = hostname If this parameter is not set, the expected name is the hostname of the authorization server. This parameter is not ..."},"423":{y:0,u:"../users-guide/tibftl-transports.htm",l:-1,t:"tibftl_transports",i:0.000283620164558429,a:"Specifies whether the TIBCO FTL transports defined in \n\t\t   transports.conf are enabled or disabled. \n\t\t   tibftl_transports = enabled | disabled Unless you explicitly set this parameter to enabled, the default value is \n\t\t   disabled—that is, all transports are \n\t\t   disabled and will neither send ..."},"424":{y:0,u:"../users-guide/rendezvous-transport.htm",l:-1,t:"Rendezvous Transport Parameters",i:0.000227983329142783,a:"Rendezvous Transport Parameters For more information, see  Interoperation With TIBCO Rendezvous ."},"425":{y:0,u:"../users-guide/tibrv-transports.htm",l:-1,t:"tibrv_transports",i:0.000262088090307263,a:"Specifies whether TIBCO Rendezvous transports defined in \n\t\t   transports.conf are enabled or disabled. \n\t\t tibrv_transports = enabled | disabled Unless you explicitly set this parameter to enabled, the default value is \n\t\t   disabled—that is, all transports are disabled and will neither send ..."},"426":{y:0,u:"../users-guide/tracing-and-log-file.htm",l:-1,t:"Tracing and Log File Parameters",i:0.000373324830338151,a:"See \n\t\t Monitor Server Activity,  for more information about these parameters.\n When using FTL stores, only the client_trace, console_trace, and trace_client_host parameters are applicable. All other log file related parameters are unsupported. See  Logging With FTL Stores  for details.\t "},"427":{y:0,u:"../users-guide/client-trace.htm",l:-1,t:"client_trace",i:0.000262088090307263,a:"Administrators can trace a connection or group of connections. When this property is enabled, the server instructs each client to generate trace output for opening or closing a connection, message activity, and transaction activity. This type of tracing does not require restarting the client ..."},"428":{y:0,u:"../users-guide/console-trace.htm",l:-1,t:"console_trace",i:0.000262088090307263,a:"Sets trace options for output to \n\t stderr. The possible values are the same as for \n\t log_trace. However, console tracing is independent of log file tracing. \n   console_trace = traceOptions If \n\t\t  logfile is defined, you can stop console output by specifying: \n\t\t console_trace=-DEFAULT \n          ..."},"429":{y:0,u:"../users-guide/logfile.htm",l:-1,t:"logfile",i:0.00174277208653661,a:"Name and location of the server log file.\n   logfile = pathname If the \n\t\t  pathname contains spaces, it must be enclosed in double quotes.\n\t\t By default, the logfile specified here is used by both servers in fault tolerant pair. Optionally, a JSON-configured server pair can set the \n\t\t   ..."},"430":{y:0,u:"../users-guide/log-trace.htm",l:-1,t:"log_trace",i:0.000262088090307263,a:"Sets the trace preference on the file defined by the \n\t logfile parameter. If \n\t logfile is not set, the values have no effect. \n   log_trace = traceOptions The value of this parameter is a comma-separated list of trace options. For a list of trace options and their meanings, see \n\t\t   Server ..."},"431":{y:0,u:"../users-guide/logfile-max-count.htm",l:-1,t:"logfile_max_count",i:0.000310535257372386,a:"logfile_max_count Specifies the maximum number of log files to be kept. \n   logfile_max_count = integer Specify any number greater than 2. \n\t\t When 0 or not specified, there is no limit to the number of log files kept. \n\t\t"},"432":{y:0,u:"../users-guide/logfile-max-size.htm",l:-1,t:"logfile_max_size",i:0.000310535257372386,a:"Specifies the recommended maximum log file size before the log file is rotated. Set to 0 to specify no limit. Use KB, MB, or GB for units (if no units are specified, the file size is assumed to be in bytes). \n   logfile_max_size = size [KB|MB|GB] The server periodically checks the size of the ..."},"433":{y:0,u:"../users-guide/secondary-logfile.htm",l:-1,t:"secondary_logfile",i:0.00174277208653661,a:"Name and location of the server log file used by the secondary EMS server in a fault tolerant pair. The EMS server designated as primary in the pair writes to the file specified by the \n\t logfile parameter.\n   secondary_logfile = pathname If the \n\t\t  secondary_logfile parameter is not set, the ..."},"434":{y:0,u:"../users-guide/trace-client-host.htm",l:-1,t:"trace_client_host",i:0.000262088090307263,a:"Trace statements related to connections can identify the host by its hostname, its IP address, or both. When absent, the default is \n\t hostname. The \n\t both_with_port option displays the ephemeral port used on the host as well as the IP address and hostname. \n   trace_client_host = ..."},"435":{y:0,u:"../users-guide/statistic-gathering-.htm",l:-1,t:"Statistic Gathering Parameters",i:0.000227983329142783,a:"Statistic Gathering Parameters See \n\t\t Monitor Server Activity,  for more information about these parameters.\n\t "},"436":{y:0,u:"../users-guide/server-rate-interval.htm",l:-1,t:"server_rate_interval",i:0.00040127749122291,a:"Sets the interval (in seconds) over which overall server statistics are averaged. \n   server_rate_interval = seconds This parameter can be set to any positive integer greater than zero. \n\t\t Overall server statistics are always gathered, so this parameter cannot be set to zero. By default, this ..."},"437":{y:0,u:"../users-guide/statistics.htm",l:-1,t:"statistics",i:0.000262088090307263,a:"statistics Enables or disables statistic gathering for producers, consumers, destinations, and routes. By default this parameter is set to disabled. \n   statistics = enabled | disabled Disabling statistic gathering resets the total statistics for each object to zero. \n\t\t"},"438":{y:0,u:"../users-guide/rate-interval.htm",l:-1,t:"rate_interval",i:0.000262088090307263,a:"rate_interval Sets the interval (in seconds) over which statistics for routes, destinations, producers, and consumers are averaged.\n   rate_interval = seconds By default, this parameter is set to 3 seconds. Setting this parameter to zero disables the average calculation.\n\t\t"},"439":{y:0,u:"../users-guide/detailed-statistics2.htm",l:-1,t:"detailed_statistics",i:0.000262088090307263,a:"Specifies which objects should have detailed statistic tracking.\n   detailed_statistics = NONE | [PRODUCERS,CONSUMERS,ROUTES] Detailed statistic tracking is only appropriate for routes, producers that specify no destination, or consumers that specify wildcard destinations. When detailed tracking is ..."},"440":{y:0,u:"../users-guide/statistics-cleanup-i.htm",l:-1,t:"statistics_cleanup_interval",i:0.000262088090307263,a:"Specifies how long (in seconds) the server should keep detailed statistics if the destination has no activity.\n   statistics_cleanup_interval = seconds This is useful for controlling the amount of memory used by detailed statistic tracking. When the specified interval is reached, statistics for ..."},"441":{y:0,u:"../users-guide/max-stat-memory.htm",l:-1,t:"max_stat_memory",i:0.000262088090307263,a:"Specifies the maximum amount of memory to use for detailed statistic gathering.\n   max_stat_memory = size [KB|MB|GB] If no units are specified, the amount is in bytes, otherwise you can specify the amount using KB, MB, or GB as the units.\n\t\t Once the maximum memory limit is reached, the server stops ..."},"442":{y:0,u:"../users-guide/tls-server-parameter.htm",l:-1,t:"TLS Server Parameters",i:0.000771988554528344,a:"TLS Server Parameters See \n\t\t TLS Protocol  for more information about these parameters. \n\t "},"443":{y:0,u:"../users-guide/ssl-server-ciphers.htm",l:-1,t:"ssl_server_ciphers",i:0.000300845823959361,a:"Specifies the cipher suites used by the server; each suite in the list is separated by a colon (:). This parameter must follow the OpenSSL cipher string syntax. \n   ssl_server_ciphers = cipherSuites For example, you can enable the cipher suites for security level 2 with the following setting: \n\t\t ..."},"444":{y:0,u:"../users-guide/ssl-require-client-c.htm",l:-1,t:"ssl_require_client_cert",i:0.000573013690782083,a:"If this parameter is set to \n\t enable, the server only accepts TLS connections from clients that have digital certificates. Connections from clients without certificates are denied. \n   ssl_require_client_cert = enable | disable If this parameter is set to \n\t\t   disable, then connections are ..."},"445":{y:0,u:"../users-guide/ssl-require-route-ce.htm",l:-1,t:"ssl_require_route_cert_only",i:0.000365787895063336,a:"This parameter overrides the \n\t ssl_require_client_cert parameter. \n   ssl_require_route_cert_only = enable | disable If \n\t\t  ssl_require_route_cert_only is set to \n\t\t   enable, the server requires a digital certificate only for TLS connections coming from routes,  regardless of the value of \n\t\t   ..."},"446":{y:0,u:"../users-guide/ssl-use-cert-usernam.htm",l:-1,t:"ssl_use_cert_username",i:0.000262088090307263,a:"If this parameter is set to enable, a client’s user name is always extracted from the CN field of the client’s digital certificate, if the digital certificate is specified. \n   ssl_use_cert_username = enable | disable If a different username is provided through the connection factory or API calls, ..."},"447":{y:0,u:"../users-guide/ssl-cert-user-specna.htm",l:-1,t:"ssl_cert_user_specname",i:0.000262088090307263,a:"This parameter is useful if clients are required to supply a username, but you wish to designate a special username to use when the client’s username should be taken from the client’s digital certificate. \n   ssl_cert_user_specname = username For example, you may wish all clients to specify their ..."},"448":{y:0,u:"../users-guide/ssl-server-identity.htm",l:-1,t:"ssl_server_identity",i:0.000262088090307263,a:"The server’s digital certificate in PEM, DER, or PKCS#12 format. You can specify the path to a file that contains the certificate in one of the supported formats. \n   ssl_server_identity = certificate This parameter must be specified if any TLS ports are listed in the \n\t\t  listen parameter. \n\t\t PEM ..."},"449":{y:0,u:"../users-guide/ssl-server-key.htm",l:-1,t:"ssl_server_key",i:0.000262088090307263,a:"The server’s private key. If it is included in the digital certificate in \n\t ssl_server_identity, then this parameter is not needed.\n   ssl_server_key = private_key This parameter supports private keys in the following formats: PEM, DER, PKCS#8, PKCS#12.\n\t\t You must specify a path to a file that ..."},"450":{y:0,u:"../users-guide/ssl-password.htm",l:-1,t:"ssl_password",i:0.000505682709535397,a:"Private key or password for private keys. This password can optionally be specified on the command line when \n\t tibemsd is started. \n   ssl_password = password If TLS is enabled, and the password is not specified with this parameter or on the command line, \n\t\t  tibemsd will ask for the password upon ..."},"451":{y:0,u:"../users-guide/ssl-server-issuer.htm",l:-1,t:"ssl_server_issuer",i:0.000262088090307263,a:"Certificate chain member for the server. The server reads the certificates in the chain in the order they are presented in this parameter. \n   ssl_server_issuer = chain_member The same certificate can appear in multiple places in the certificate chain. \n\t\t The certificates must be in PEM, DER, ..."},"452":{y:0,u:"../users-guide/ssl-server-trusted.htm",l:-1,t:"ssl_server_trusted",i:0.000942948493742995,a:"List of CA root certificates the server trusts as issuers of client certificates. \n   ssl_server_trusted = certificates Specify only CA root certificates. Do not include intermediate CA certificates. \n\t\t The certificates must be in PEM, DER, or PKCS#7 format. You can either provide the actual ..."},"453":{y:0,u:"../users-guide/ssl-crl-path.htm",l:-1,t:"ssl_crl_path",i:0.000262088090307263,a:"A non-null value for this parameter activates the server’s certificate revocation list (CRL) feature. \n   ssl_crl_path = pathname The server reads CRL files from this directory. The directory should contain only CRL files. If other files are located in the \n\t\t  pathname directory, TLS initialization ..."},"454":{y:0,u:"../users-guide/ssl-crl-update-inter.htm",l:-1,t:"ssl_crl_update_interval",i:0.000262088090307263,a:"ssl_crl_update_interval The server automatically updates its CRLs at this interval (in hours).\n   ssl_crl_update_interval = hours When this parameter is absent, the default is 24 hours.\n\t\t"},"455":{y:0,u:"../users-guide/ssl-auth-only.htm",l:-1,t:"ssl_auth_only",i:0.000406474753432354,a:"When enabled, the server allows clients to request the use of TLS only for authentication (to protect user passwords). \n   ssl_auth_only = enable | disable For an overview of this feature, see \n\t\t   TLS Authentication Only . \n\t\t When disabled, the server ignores client requests for this feature. ..."},"456":{y:0,u:"../users-guide/fips140-2.htm",l:-1,t:"fips140-2",i:0.000300845823959361,a:"fips140-2 When \n\t true, the EMS server is enabled to run in FIPS 140-2 compliant mode. When \n\t false or excluded, the server is not FIPS compliant. \n   fips140-2 = true | false For more information, see \n\t\t   Enable FIPS Compliance . \n\t\t"},"457":{y:0,u:"../users-guide/https-server-parameter.htm",l:-1,t:"TLS Server Parameters",i:0.000406369143608049,a:"HTTPS Server Parameters See \n\t\t TLS Protocol  for more information about these parameters. \n\t "},"458":{y:0,u:"../users-guide/monitor_ssl_identity.htm",l:-1,t:"ssl_server_ciphers",i:0.000227983329142783,a:"monitor_ssl_identity The digital certificate used for the  Server Health and Metrics  HTTPS listen in PEM, DER, or PKCS#12 format. You can specify the path to a file that contains the certificate in one of the supported formats.\n monitor_ssl_identity = certificate If this parameter is not specified, ..."},"459":{y:0,u:"../users-guide/monitor_ssl_key.htm",l:-1,t:"ssl_server_ciphers",i:0.000227983329142783,a:"monitor_ssl_key The private key used for the  Server Health and Metrics  HTTPS listen. If it is included in the digital certificate in monitor_ssl_identity, then this parameter is not needed. monitor_ssl_key = private_key If this parameter is not specified, the private key file configured for the ..."},"460":{y:0,u:"../users-guide/monitor_ssl_password.htm",l:-1,t:"ssl_server_ciphers",i:0.000227983329142783,a:"monitor_ssl_password Password for the private key used for the  Server Health and Metrics  HTTPS listen.\n monitor_ssl_password = password If this parameter is not specified, the password for the private key file configured for the server’s TLS listen is used in its place. If neither are specified, ..."},"461":{y:0,u:"../users-guide/monitor_ssl_trusted.htm",l:-1,t:"ssl_server_ciphers",i:0.000227983329142783,a:"monitor_ssl_trusted List of CA root certificates the server trusts as issuers of client certificates. This list only applies to incoming connections on the  Server Health and Metrics  HTTPS listen. monitor_ssl_trusted = certificates If this parameter is not specified, an attempt is made to use the ..."},"462":{y:0,u:"../users-guide/OAuth-2.0-Parameters.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000324877663273029,a:"OAuth 2.0 Parameters See  Authentication Using OAuth 2.0  for more information on using OAuth 2.0 in EMS. \n\t "},"463":{y:0,u:"../users-guide/oauth2_server_validation_key.htm",l:-1,t:"ft_ssl_ciphers",i:0.000560075545134423,a:"oauth2_server_validation_key Specifies the path to a file containing the PEM-encoded public key or JSON Web Key Set (JWKS) to use for validating the signature of an OAuth 2.0 JWT access token presented by an incoming connection request.  oauth2_server_validation_key = public_key|JWKS"},"464":{y:0,u:"../users-guide/oauth2_user_claim.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"oauth2_user_claim Specifies the claim in the OAuth 2.0 access token that contains the EMS user to associate with the incoming connection request. oauth2_user_claim = claim_name"},"465":{y:0,u:"../users-guide/oauth2_group_claim.htm",l:-1,t:"ft_ssl_ciphers",i:0.000262088090307263,a:"oauth2_group_claim Specifies the claim in the OAuth 2.0 access token that contains the list of groups that the EMS user belongs to. oauth2_group_claim = claim_name This parameter is optional. If not specified, the EMS server will assume that the incoming connection is associated with an EMS user ..."},"466":{y:0,u:"../users-guide/oauth2_audience.htm",l:-1,t:"ft_ssl_ciphers",i:0.000560075545134423,a:"oauth2_audience Specifies the expected value of the ‘aud’ claim in the access token presented by the incoming connection request.  oauth2_audience = audience The EMS server can be configured to accept multiple audience values. For example: oauth2_audience = ems_aud1\noauth2_audience = ems_aud2\n This ..."},"467":{y:0,u:"../users-guide/extensible-security-.htm",l:-1,t:"Extensible Security Parameters",i:0.000227983329142783,a:"Extensible Security Parameters The extensible security feature allows you to write your own authentication and permissions modules for the server.\n   For more information on this feature, see \n\t\t Extensible Security .\n\t "},"468":{y:0,u:"../users-guide/jaas-config-file.htm",l:-1,t:"jaas_config_file",i:0.000872206077619254,a:"Specifies the location of the JAAS configuration file used by the EMS server to run a custom authentication \n\t LoginModule. \n   jaas_config_file = file-name For more information, see \n\t\t   Loading the LoginModule in the EMS Server . \n\t\t This parameter is required to enable the extensible security ..."},"469":{y:0,u:"../users-guide/jaas-login-timeout.htm",l:-1,t:"jaas_login_timeout",i:0.000262088090307263,a:"Specifies the length of time, in milliseconds, that the EMS server will wait for the JAAS authentication module to execute and respond. \n   jaas_login_timeout = milliseconds This timeout is used each time the server passes a username and password to the LoginModule. If the module does not return a ..."},"470":{y:0,u:"../users-guide/jaci-class.htm",l:-1,t:"jaci_class",i:0.000300845823959361,a:"Specifies the name of the class that implements the extensible permissions interface.\n   jaci_class = class-name The class must be written using the Java Access Control Interface (JACI). For more information about writing a custom application using JACI to grant permissions, see \n\t\t   Permissions ..."},"471":{y:0,u:"../users-guide/jaci-timeout.htm",l:-1,t:"jaci_timeout",i:0.000348627911627783,a:"Specifies the length of time, in milliseconds, that the EMS server will wait for the JACI permissions module to execute and respond.\n   jaci_timeout = milliseconds This timeout is used each time the server passes a destination, username, and action to the permissions module. If the module does not ..."},"472":{y:0,u:"../users-guide/security-classpath.htm",l:-1,t:"security_classpath",i:0.00039787628834475,a:"Includes the JAR files and dependent classes used by the JAAS LoginModules and JACI modules.\n   security_classpath = classpath This parameter is required to enable the extensible security feature for authentication and the extensible security feature for granting permissions.\n\t\t For example:\n\t\t ..."},"473":{y:0,u:"../users-guide/jvm-parameters.htm",l:-1,t:"JVM Parameters",i:0.000355798812762529,a:"JVM Parameters These parameters enable and configure the Java virtual machine (JVM) in the EMS server.\n   For more information on how the JVM works in EMS, see \n\t\t Enable the JVM .\n\t "},"474":{y:0,u:"../users-guide/jre-library.htm",l:-1,t:"jre_library",i:0.00045463592693565,a:"Enables the JVM in the EMS server, where \n\t path \n\t is the absolute path to the JRE shared library file that is installed with the JRE. \n   jre_library = path Depending on your platform, this could be \n\t\t  jvm.dll, \n\t\t  libjvm.so, \n\t\t  libjvm.dylib, and so forth. \n\t\t If this parameter is not ..."},"475":{y:0,u:"../users-guide/jre-option.htm",l:-1,t:"jre_option",i:0.000606730531033139,a:"Passes command line options to the JVM at start-up.\n   jre_option = JVMoption The \n\t\t  jre_option parameter can be used to define Java system properties, which are used by applications running in the JVM, such as extensible security modules.\n\t\t You can use multiple \n\t\t  jre_option entries in order ..."},"476":{y:0,u:"../users-guide/using-other-configur.htm",l:-1,t:"Using Other Configuration Files",i:0.000227983329142783,a:"In addition to the main configuration file, there are several other configuration files used for various purposes. \n   These configuration files can be edited by hand, but you can also use the administration tool or the administration APIs to modify some of these files. See \n\t\t   EMS Administration ..."},"477":{y:0,u:"../users-guide/bridges.conf.htm",l:-1,t:"bridges.conf",i:0.000435614045136167,a:"This file defines bridges between destinations. \n   See \n\t\t   Destination Bridges  for more information about destination bridges. \n\t\t The format of the file is: \n\t\t [destinationType:destinationName] # mandatory -- include brackets\ndestinationType=destinationToBridgeTo1 ..."},"478":{y:0,u:"../users-guide/durables.conf.htm",l:-1,t:"durables.conf",i:0.00132280770274959,a:"This file defines static durable subscribers. \n   The file consists of lines with either of these formats: \n\t\t topic-name durable-name\n  [route]\n  [clientid=id]\n  [nolocal]\n  [selector=\"msg-selector\"] Example topic1 dName1\ntopic2 dName2 clientid=myId,nolocal\ntopic3 dName3 selector=\"urgency in ..."},"479":{y:0,u:"../users-guide/factories.conf.htm",l:-1,t:"factories.conf",i:0.00489875429281343,a:"This file defines the connection factories for the internal JNDI names. \n   The file consists of factory definitions with this format: \n\t\t [factory-name] # mandatory -- square brackets included\n  type = generic|xageneric|topic|queue|xatopic|xaqueue|\n  url = url-string\n  metric = connections | ..."},"480":{y:0,u:"../users-guide/groups.conf.htm",l:-1,t:"groups.conf",i:0.000542804837643288,a:"groups.conf This file defines all groups. The format of the file is: group-name1:\"description\"\n   user-name1\n   user-name2 group-name2:\"description\"\n   user-name1\n   user-name2 Example administrators: \"TIBCO Enterprise Message Service administrators\"\n   admin\n   Bob"},"481":{y:0,u:"../users-guide/jaas.conf.htm",l:-1,t:"jaas.conf",i:0.000241825376875675,a:"jaas.conf This file directs the TIBCO Enterprise Message Service server to the JAAS LoginModule.\n   See \n\t\t   Loading the LoginModule in the EMS Server  for more information about the \n\t\t  jaas.conf file.\n\t\t"},"482":{y:0,u:"../users-guide/queues.conf.htm",l:-1,t:"queues.conf",i:0.00107284203049787,a:"This file defines all queues.\n   The format of the file is:\n\t\t [jndi-name1, jndi-name2, ...]queue-name property1, property2, ... \n                Note that, while including JNDI names is optional, the square brackets [ ] must be included around JNDI names if they are included. For more information ..."},"483":{y:0,u:"../users-guide/routes.conf.htm",l:-1,t:"routes.conf",i:0.00165597519744618,a:"This file defines routes between this TIBCO Enterprise Message Service server and other TIBCO Enterprise Message Service servers. \n   \n                Routes may only be configured administratively, using the administration tool (see \n\t\t   Using the EMS Administration Tool ), or the administration ..."},"484":{y:0,u:"../users-guide/stores.conf.htm",l:-1,t:"stores.conf",i:0.000389473886026526,a:"This file defines the locations of stores where the EMS server will store messages or metadata (if the default \n\t $sys.meta definition is overridden). You can configure one or many stores in the \n\t stores.conf file. \n   Store parameters specific to file-based stores are described here. Grid store ..."},"485":{y:0,u:"../users-guide/tibrvcm.conf.htm",l:-1,t:"tibrvcm.conf",i:0.00182929638736797,a:"This file defines the TIBCO Rendezvous certified messaging (RVCM) listeners for use by topics that export messages to a \n\t tibrvcm transport. The server preregisters these listeners when the server starts up so that all messages (including the first message published) sent by way of the \n\t tibrvcm ..."},"486":{y:0,u:"../users-guide/topics.conf.htm",l:-1,t:"topics.conf",i:0.00115636307348451,a:"This file defines all topics. \n   The format of the file is: \n\t\t [jndi-name1, jndi-name2, ...]topic-name property1, property2, ... \n                Note that, while including JNDI names is optional, the square brackets [ ] must be included around JNDI names if they are included. For more information ..."},"487":{y:0,u:"../users-guide/transports.conf.htm",l:-1,t:"transports.conf",i:0.00386605969905789,a:"This file defines transports for importing messages from or exporting messages to TIBCO FTL and Rendezvous. \n   The format of the file is: \n\t\t [transport_name] # mandatory -- square brackets included\n   type = tibftl | tibrv | tibrvcm # mandatory\n   [topic_import_dm = TIBEMS_PERSISTENT ..."},"488":{y:0,u:"../users-guide/transport-specific-p.htm",l:-1,t:"Transport-specific Parameters",i:0.00351427516080866,a:"tibftl transports If \n\t\t  type = tibftl, the extended syntax is: \n\t\t    [endpoint = endpoint-name]\n   [import_subscriber_name = subscriber-name]\n   [import_match_string = {\"fieldname1\":value1,...,\"fieldnameN\":valueN}]\n   [export_format = format-name]\n   [export_constant = ..."},"489":{y:0,u:"../users-guide/users.conf.htm",l:-1,t:"users.conf",i:0.0011673071798933,a:"This file defines all users.\n   The format of the file is:\n\t\t username:password:\"description\" Example admin::\"Administrator\"\nBob::\"Bob Smith\"\nBill::\"Bill Jones\" After the server has started and passwords have been assigned, the file will look like this:\n\t\t ..."},"490":{y:0,u:"../users-guide/authentication-and-p.htm",l:-1,t:"Authentication and Permissions",i:0.0049124015816799,a:"The EMS server supports authentication of incoming connections through user and password validation, JAAS authentication modules, and OAuth 2.0. The EMS server also supports access control (authorization) through enforcement of permissions on users and groups. EMS supports two basic levels of ..."},"491":{y:0,u:"../users-guide/setting-up-ems-acces.htm",l:-1,t:"Setting up EMS Access Control",i:0.000227983329142783,a:"Setting up EMS Authentication and Access Control The following procedure describes the general process for administrators to configure authentication and permissions and where to find more information on performing each step. Enable authentication and access control for the system. See  Enable ..."},"492":{y:0,u:"../users-guide/users-and-groups.htm",l:-1,t:"Users and Groups",i:0.000227983329142783,a:"Users and Groups The following sections describe users and groups in EMS. \n\t "},"493":{y:0,u:"../users-guide/users.htm",l:-1,t:"Users",i:0.000594180291172483,a:"Users are specific, named IDs that allow you to identify yourself to the server. When a client attempts to connect to the server, it presents a set of credentials to identify itself as a particular user. These credentials can either be a username and corresponding password, or an OAuth 2.0 access ..."},"494":{y:0,u:"../users-guide/groups.htm",l:-1,t:"Groups",i:0.000594180291172483,a:"Groups allow you to create classes of users. Groups make access control administration significantly simpler because you can grant and revoke permissions to large numbers of users with a single operation on the group. \n   Each user can belong to as many groups as necessary. A user’s permissions are ..."},"495":{y:0,u:"../users-guide/administration-comma.htm",l:-1,t:"Administration Commands and External Users and Groups",i:0.000586495318401232,a:"You can perform administrative commands on users and groups defined either locally (in the EMS server’s local configuration files), or externally (in an external directory accessed through JAAS, or in an OAuth 2.0 provider). Furthermore, you can combine users and groups that are defined in different ..."},"496":{y:0,u:"../users-guide/enable-access-contro.htm",l:-1,t:"Enable Access Control",i:0.00234525493960656,a:"Enable Authentication and Access Control Administrators can enable or disable authentication and access control for the server. Administrators can also enable and disable permission checking for specific destinations."},"497":{y:0,u:"../users-guide/server-control.htm",l:-1,t:"Server Control",i:0.000227983329142783,a:"Server Access Control and Authentication The  authorization  property in the main configuration file enables or disables authentication of incoming connections and the checking of permissions for all destinations managed by the server.\n   \n            The default setting is \n\t\tdisabled. For secure ..."},"498":{y:0,u:"../users-guide/destination-control.htm",l:-1,t:"Destination Control",i:0.000271680773946619,a:"Destination Access Control  When  authorization  is enabled, the server verifies user and group permissions before allowing operations on destinations, such as sending a message or receiving a message. However, this destination access control is only applicable for those destinations that have the  ..."},"499":{y:0,u:"../users-guide/Authentication-Methods.htm",l:-1,t:"ft_ssl_ciphers",i:0.00127015904762726,a:"Authentication Methods The parameter  user_auth  in tibemsd.conf determines the authentication methods the EMS server can use to authenticate incoming connection requests - either from EMS clients or other EMS servers. This parameter can have one or more of the following values (separated by comma ..."},"500":{y:0,u:"../users-guide/Authentication-Using-OAuth-2.0.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.00157125285139068,a:"Authentication Using OAuth 2.0 TIBCO EMS supports authentication of client connections via OAuth 2.0. When connecting to an EMS server configured with OAuth 2.0 authentication, an EMS client must authenticate itself to the server by presenting an access token issued by an OAuth 2.0 authorization ..."},"501":{y:0,u:"../users-guide/Obtaining-an-Access-Token.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000227983329142783,a:"Obtaining an Access Token EMS clients require an access token to connect to an EMS server configured with OAuth 2.0 authentication. Additionally, an EMS server itself may require an access token to connect to another EMS server or a TIBCO messaging product that is configured for OAuth 2.0 ..."},"502":{y:0,u:"../users-guide/Client-Credentials-Grant.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000618307656459757,a:"Client Credentials Grant In the Client Credentials grant, the EMS client (or EMS server) presents a client ID and client secret to the OAuth 2.0 authorization server. The authorization server uses these credentials to authenticate the EMS client and issues it an access token. This is the preferred ..."},"503":{y:0,u:"../users-guide/Resource-Owner-Password-Credentials-Grant.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000618307656459757,a:"Resource Owner Password Credentials Grant In the resource owner password credentials grant, the EMS client (or EMS server) first authenticates itself to the OAuth 2.0 authorization server by presenting a client ID and client secret, then provides an EMS user and password for validation by the ..."},"504":{y:0,u:"../users-guide/Using-anExistingAccessToken-in-the-EMS-Client.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000227983329142783,a:"Using Externally-Obtained Access Tokens In addition to the above grant types, the EMS client APIs and the EMS server can be configured to use access tokens obtained via external means. If access tokens are directly configured in this manner, the EMS server and client APIs will not attempt to obtain ..."},"505":{y:0,u:"../users-guide/AccessTokenExpiration.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.00151640870430473,a:"Access Token Expiration OAuth 2.0 JWT access tokens can have an expiration time specified through the ‘exp’ claim. The EMS server enforces access token expiration by disconnecting the associated EMS client (or EMS server). In order to minimize connection disruptions due to access token expirations, ..."},"506":{y:0,u:"../users-guide/Configure-OAuth-2.0-in-EMS-Server.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000227983329142783,a:"Configure OAuth 2.0 in the EMS Server To enable OAuth 2.0 authentication of incoming connections to the EMS server, add oauth2 to the user_auth server parameter. user_auth=oauth2 The EMS server can be configured to use oauth2 alongside other authentication methods. See  Authentication Methods  for ..."},"507":{y:0,u:"../users-guide/Access-Tokens-for-OutgoingConnections.htm",l:-1,t:"TIBCO FTL Transport Parameters",i:0.000227983329142783,a:"Access Tokens for Outgoing Connections Depending on its configuration, the EMS server may need to initiate an outgoing connection to a different EMS server or another TIBCO messaging product that is configured with OAuth 2.0 authentication. In these scenarios, the EMS server requires additional ..."},"508":{y:0,u:"../users-guide/authenticate-adminis.htm",l:-1,t:"Authenticate Administrative Connections",i:0.000227983329142783,a:"Administrative connections, such as those created by the EMS Administration Tool and the EMS administrative API, are authenticated differently than client connections. When establishing an administrative connection, local authentication is always attempted first, regardless of the authentication ..."},"509":{y:0,u:"../users-guide/administrator-permis.htm",l:-1,t:"Administrator Permissions",i:0.00164888385257704,a:"Administrators are a special class of users that can manage the EMS server. Administrators create, modify, and delete users, destinations, routes, factories, and other items. In general, administrators must be granted permission to perform administration activities when using the Administration Tool ..."},"510":{y:0,u:"../users-guide/predefined-administr.htm",l:-1,t:"Predefined Administrative User and Group",i:0.000227983329142783,a:"There is a special, predefined user named \n\t admin that can perform any administrative action. You cannot grant or revoke any permissions to admin. You must assign a password for \n\t admin immediately after installation. \n   For more information about changing the \n\t\tadmin password, see \n\t\t When You ..."},"511":{y:0,u:"../users-guide/granting-and-revokin.htm",l:-1,t:"Granting and Revoking Administration Permissions",i:0.000227983329142783,a:"You grant and revoke administrator permissions to users using the \n\t grant and \n\t revoke commands in \n\t tibemsadmin, or by means of the Java or .NET administration API. You can either grant global administrator permissions or permissions on specific destinations. \n   See \n\t\t Global Administrator ..."},"512":{y:0,u:"../users-guide/enforcement-of-admin.htm",l:-1,t:"Enforcement of Administrator Permissions",i:0.000227983329142783,a:"An administrator can only perform actions for which the administrator has been granted permission. Any action that an administrator performs may be limited by the set of permissions granted to that administrator. \n   For example, an administrator has been granted the view permission on the \n\t\tfoo.* ..."},"513":{y:0,u:"../users-guide/global-administrator.htm",l:-1,t:"Global Administrator Permissions",i:0.000470219164468397,a:"Certain permissions allow administrators to perform global actions, such as creating users or viewing all queues. \n   The following table describes the global administrator permissions. \n\t\t \n                Any type of modification to an item requires that the user can view that item. Therefore, ..."},"514":{y:0,u:"../users-guide/destination-level-pe.htm",l:-1,t:"Destination-Level Permissions",i:0.000585525489166967,a:"Administrators can be granted permissions on each destination. Destination-level permissions control the administration functions a user can perform on a specific destination. Global permissions granted to a user override any destination-level permissions. \n   The typical use of destination-level ..."},"515":{y:0,u:"../users-guide/protection-permissio.htm",l:-1,t:"Protection Permissions",i:0.000276430496207906,a:"Protection permissions allow you to group users into administrative domains so that administrators can only perform actions within their domain. An administrator can only perform administrative operations on a user that has the same protection permission as the user. \n   There are four protection ..."},"516":{y:0,u:"../users-guide/user-permissions.htm",l:-1,t:"User Permissions",i:0.00136682014044939,a:"User permissions are stored in the access control list and determine the actions a user can perform on a destination. A user’s permissions are the union of the permissions granted explicitly to that user along with any permissions the user receives by belonging to a group.\n   When granting user ..."},"517":{y:0,u:"../users-guide/queue-and-topic-perm.htm",l:-1,t:"Queue and Topic Permissions",i:0.000892403699685446,a:"The permissions that can be granted to users to access queues and topics are listed in the following tables. \n   Topic Permission Name \n\t\t\t\t Description \n\t\t\t\t subscribe permission to create non-durable subscribers on the topic \n\t\t\t\t publish permission to publish on the topic \n\t\t\t\t durable permission ..."},"518":{y:0,u:"../users-guide/example-of-setting-u.htm",l:-1,t:"Example of Setting User Permissions",i:0.000227983329142783,a:"The user \n\t\tbob has the following permission recorded in the \n\t\tacl.conf file: \n\t  USER=bob TOPIC=foo PERM=subscribe,publish This set of permissions means that \n\t\tbob can subscribe to topic \n\t\tfoo and publish messages to it, but \n\t\tbob cannot create durable subscribers to \n\t\tfoo. \n\t  If \n\t\tbob is a ..."},"519":{y:0,u:"../users-guide/inheritance-of-user-.htm",l:-1,t:"Inheritance of User Permissions",i:0.000460348594188324,a:"When you grant permissions to users for topics or queues with wildcard specifications, all created topics and queues that match the specification will have the same granted permissions as the permissions on the parent topic.\n   If there are multiple parent topics, the user receives the union of all ..."},"520":{y:0,u:"../users-guide/revoking-user-permis.htm",l:-1,t:"Revoking User Permissions",i:0.000227983329142783,a:"Administrators can revoke permissions for users to create consumers on a destination. Without permission, the user cannot create new consumers for a destination—however, existing consumers of the destination continue to receive messages.\n   You can only revoke a permission that is granted directly. ..."},"521":{y:0,u:"../users-guide/when-permissions-are.htm",l:-1,t:"When Permissions Are Checked",i:0.00116694336804095,a:"If permissions are enforced (that is, the \n\t\t authorization configuration property is set, and the \n\t\t secure property is set for the destination), the server checks them when a user attempts to perform an operation on a destination. For example, create a subscription to a topic, send a message to a ..."},"522":{y:0,u:"../users-guide/example-of-permissio.htm",l:-1,t:"Example of Permission Checking",i:0.000227983329142783,a:"This example walks through a scenario for granting and revoking permissions to a user, and describes what happens as various operations are performed. \n   User bob is working with a EMS application that subscribes to topics and displays any messages sent to those topics. \n\t\t User bob creates a ..."},"523":{y:0,u:"../users-guide/extensible-security.htm",l:-1,t:"Extensible Security",i:0.000880076942590168,a:"Extensible Security The following sections outline how to develop and implement custom authentication and permissions modules. \n  "},"524":{y:0,u:"../users-guide/overview-of-extensib.htm",l:-1,t:"Overview of Extensible Security",i:0.000227983329142783,a:"The extensible security feature allows you to use your own authentication and permissions systems, in addition to the prebuilt JAAS modules included in EMS, to authenticate users and authorize them to perform actions such as publish and subscribe operations. Developing custom applications to grant ..."},"525":{y:0,u:"../users-guide/how-extensible-secur.htm",l:-1,t:"How Extensible Security Works",i:0.000227983329142783,a:"Extensible security works by allowing you to write your own authentication and permissions modules, which run in a Java virtual machine (JVM) in the EMS server. The modules connect to the server using the Java Authentication and Authorization Service (JAAS) for authentication modules, and the Java ..."},"526":{y:0,u:"../users-guide/extensible-authentic.htm",l:-1,t:"Extensible Authentication",i:0.00112028803788753,a:"The extensible authentication feature uses the Java virtual machine (JVM) and the Java Authentication and Authorization Service (JAAS) to allow you to run your own Java-based authentication module in the EMS server.\n   Your authentication module, or LoginModule, runs in the JVM within the EMS ..."},"527":{y:0,u:"../users-guide/enable-extensible-au.htm",l:-1,t:"Enable Extensible Authentication",i:0.000227983329142783,a:"Extensible authentication is enabled in the EMS server, through parameters in the \n\t tibemsd.conf configuration file. The required parameters are:\n\t  authorization—directs the server to verify user credentials and permissions on secure destinations.\n\t\t user_auth—directs the EMS server to use the ..."},"528":{y:0,u:"../users-guide/prebuilt-authenticat.htm",l:-1,t:"Prebuilt Authentication Modules",i:0.000227983329142783,a:"TIBCO Enterprise Message Service includes several supported JAAS authentication modules that offer flexible authentication for the EMS server. The source files of the prebuilt modules are provided in \n\t  EMS_HOME/src/java/jaas, and provide an excellent template for developing custom modules. ..."},"529":{y:0,u:"../users-guide/writing-an-authentic.htm",l:-1,t:"Writing an Authentication Module",i:0.000227983329142783,a:"The LoginModule is a custom module that runs inside the EMS server within a JVM. The LoginModule is written using JAAS, a set of APIs provided by Sun Microsystems, and used to create plugable Java applications. JAAS provides the interface between your code and the EMS server. JAAS is a standard part ..."},"530":{y:0,u:"../users-guide/loginmodule-requirem.htm",l:-1,t:"LoginModule Requirements",i:0.000227983329142783,a:"In order to implement extensible authentication, you must write a LoginModule implementing the JAAS interface. \n\t  There are some requirements for a LoginModule that will run in the EMS server: \n\t  The LoginModule must accept the username and password from the EMS server by way of the \n\t\t  ..."},"531":{y:0,u:"../users-guide/load-the-loginmodule.htm",l:-1,t:"Load the LoginModule in the EMS Server",i:0.00120723151338945,a:"The EMS server locates and loads the LoginModule based on the contents of the configuration file specified by the \n\t\t jaas_config_file  parameter in the \n\t\t tibemsd.conf file. Usually, the JAAS configuration file is named \n\t\tjaas.conf. This file contains the configuration information used to invoke ..."},"532":{y:0,u:"../users-guide/extensible-permissio.htm",l:-1,t:"Extensible Permissions",i:0.000421771997403274,a:"The extensible permissions feature uses the Java virtual machine (JVM) and the Java Access Control Interface (JACI) to allow you to run your own Java-based permissions module in the EMS server.\n   Your Permissions Module runs in the JVM within the EMS server, and connects to \n\t\ttibemsd using the ..."},"533":{y:0,u:"../users-guide/cached-permissions.htm",l:-1,t:"Cached Permissions",i:0.000227983329142783,a:"In order to speed the authorization process, the EMS server caches responses received from the Permissions Module in two pools, the allow cache and the deny cache. Before invoking the Permissions Module, the server first checks these caches for a cache entry matching the user’s request."},"534":{y:0,u:"../users-guide/what-is-cached.htm",l:-1,t:"What is Cached",i:0.000227983329142783,a:"Each cache entry consists of a username and action, and the authorization result response from the Permissions Module. \n\t  Properties of cache entries: \n\t  The username is specific; the cached permission applies only to this user. \n\t\t The action is also specific. Only one action is included in each ..."},"535":{y:0,u:"../users-guide/how-long-permissions.htm",l:-1,t:"How Long Permissions are Cached",i:0.000227983329142783,a:"Permissions Module results also include timeouts, which determine how long the cache entry is kept in the cache before it expires.\n   When a timeout has expired, the entry is removed from the cache. Because these timeouts are assigned by the Permissions Module, you can control how often the ..."},"536":{y:0,u:"../users-guide/administer-the-cache.htm",l:-1,t:"Administer the Cache",i:0.000227983329142783,a:"Administer the Cache You can view and reset cache statistics, as well as clear all cache entries.\n   These commands are available in the administration tool:\n\t  jaci showstats jaci resetstats jaci clear"},"537":{y:0,u:"../users-guide/granting-permissions.htm",l:-1,t:"How Permissions are Granted",i:0.000407239323772007,a:"When an EMS client attempts to perform an action that requires permissions, the EMS server looks in several locations for authorization. \n   First, the server checks the \n\t\t\t acl.conf for authorization. This is the standard EMS mechanism for granting permissions, as is documented in \n\t\t\t  ..."},"538":{y:0,u:"../users-guide/durable-subscribers.htm",l:-1,t:"Durable Subscribers",i:0.000227983329142783,a:"When a durable subscriber is disconnected from the EMS server, the server continues to accumulate messages for the client. However, while the client is disconnected, there is no user associated with the durable subscriber. Because of this, the server cannot immediately check permissions for a ..."},"539":{y:0,u:"../users-guide/special-circumstance.htm",l:-1,t:"Special Circumstances",i:0.000227983329142783,a:"There are some special circumstances under which the request, although it is not exactly matched in the acl.conf file, will be denied without reference to either the permissions cache or the Permissions Module. Any request will be denied if, in the acl.conf The username exists but is not associated ..."},"540":{y:0,u:"../users-guide/implications-of-wild.htm",l:-1,t:"Implications of Wildcards on Permissions",i:0.000314523150463303,a:"A permission result from the Permissions Module can allow or deny the user authorization to perform the action on a range of destinations by including wildcards in the destination name.\n   For example, even though the application attempts to have user \n\t\tmwalton publish on topic \n\t\tfoo.bar.1, the ..."},"541":{y:0,u:"../users-guide/enable-extensible-pe.htm",l:-1,t:"Enable Extensible Permissions",i:0.000227983329142783,a:"Extensible permissions are enabled in the EMS server, through parameters in the \n\t tibemsd.conf configuration file.\n   The required parameters are:\n\t  authorization—enables authorization.\n\t\t jaci_class—specifies the class that implements the Permissions Module.\n\t\t security_classpath—specifies the ..."},"542":{y:0,u:"../users-guide/permissions-module.htm",l:-1,t:"Permissions Module",i:0.000483706786867271,a:"The Permissions Module is a custom module that runs inside the EMS server within a JVM. The Permissions Module is written using JACI, a set of APIs developed by TIBCO Software Inc. that you can use to create a Java module that will authorize EMS client requests. \n   JACI provides the interface ..."},"543":{y:0,u:"../users-guide/requirements.htm",l:-1,t:"Requirements",i:0.000227983329142783,a:"In order to implement extensible permissions, you must write a Permissions Module implementing the JACI interface. \n   There are some requirements for a Permissions Module that will run in the EMS server: \n\t  The Permissions Module must implement the JACI \n\t\t  Authorizer interface, which accepts ..."},"544":{y:0,u:"../users-guide/the-jvm-in-the-ems-s.htm",l:-1,t:"The JVM in the EMS Server",i:0.000292715682151424,a:"The Java virtual machine (JVM) is a virtual machine on the Java platform, capable of running inside the EMS server. \n   Select independent Java modules can operate in the JVM and plug into the EMS server. The JVM is required to use the following TIBCO Enterprise Message Service features: \n\t  ..."},"545":{y:0,u:"../users-guide/enable-the-jvm.htm",l:-1,t:"Enable the JVM",i:0.000601473482423754,a:"The Java virtual machine is enabled in the EMS server, through parameters in the \n\t tibemsd.conf configuration file. \n   The parameters that enable and configure the JVM are: \n\t  jre_library—enables the JVM. \n\t\t jre_option—allows you to pass standard JVM options, defined by Sun Microsystems, to the ..."},"546":{y:0,u:"../users-guide/jaas-authentication-.htm",l:-1,t:"JAAS Authentication Modules",i:0.000584935825589315,a:"JAAS Authentication Modules TIBCO provides several compiled and fully functional JAAS modules that can be used to enable LDAP and host-based authentication in the EMS server."},"547":{y:0,u:"../users-guide/overview-of-the-jaas.htm",l:-1,t:"Overview of the JAAS Authentication Modules",i:0.000227983329142783,a:"Overview of the JAAS Authentication Modules The JAAS Authentication modules are LoginModules that use the JVM in the EMS server to authenticate connections to the EMS server. Refer to  Extensible Authentication  for further information the use of JAAS in TIBCO Enterprise Message Service."},"548":{y:0,u:"../users-guide/prebuilt-jaas-module.htm",l:-1,t:"Prebuilt JAAS Modules",i:0.000227983329142783,a:"TIBCO Enterprise Message Service provides a number of JAAS modules that can be used with the EMS server. These default modules are very flexible, and offer a variety of configuration options to suit most needs. \n   An EMS server file, \n\t\ttibemsd-jaas.conf, that is preconfigured to use the prebuilt ..."},"549":{y:0,u:"../users-guide/custom-jaas-modules.htm",l:-1,t:"Custom JAAS Modules",i:0.000586495318401232,a:"The default JAAS modules included with your TIBCO Enterprise Message Service installation will accommodate most environments. However, sometimes specialized support for authentication is required. To support this, well-documented source-code is provided for all of the EMS JAAS modules in the ..."},"550":{y:0,u:"../users-guide/multiple-jaas-module.htm",l:-1,t:"Multiple JAAS Modules",i:0.000227983329142783,a:"The prebuilt JAAS modules support stacking, which provides great flexibility. Using multiple modules, you can direct the EMS server to check authentication using any arrangement of the modules. A common example would stack the LDAP Authentication module with the Host Based Authentication module to ..."},});