define({"732":{y:0,u:"../users-guide/server-tracing-optio.htm",l:-1,t:"Server Tracing Options",i:0.000849469412805957,a:"When configuring log or console tracing, you have a variety of options for the types of trace messages that can be generated. \n   Specify tracing with a comma-separated list of trace options. You may specify trace options in three forms: \n\t\t plain:  A trace option without a prefix character replaces ..."},"733":{y:0,u:"../users-guide/message-tracing.htm",l:-1,t:"Message Tracing",i:0.00199644221870787,a:"In addition to other server activity, you can trace messages as they are processed. \n   Trace entries for messages are only generated for destinations or messages that specify tracing should be performed. For destinations, you specify the \n\t\ttrace property to enable the generation of trace messages. ..."},"734":{y:0,u:"../users-guide/enable-message-traci2.htm",l:-1,t:"Enable Message Tracing for a Destination",i:0.000227983329142783,a:"The \n\t trace property on a destination specifies that trace entries are generated for that destination.\n   The trace property can optionally be specified as \n\t\ttrace=body. Setting trace=body includes the message body in trace messages. The EMS server prints up to one kilobyte of a message string ..."},"735":{y:0,u:"../users-guide/enable-message-traci.htm",l:-1,t:"Enable Message Tracing on a Message",i:0.000227983329142783,a:"You can enable tracing on individual messages by setting the \n\t JMS_TIBCO_MSG_TRACE property on the message.\n   The value of the property can be either null (Java/.NET null or NULL in C) or the string \"body\". Setting the property to null specifies only the message ID and message sequence will be ..."},"736":{y:0,u:"../users-guide/monitor-server-event.htm",l:-1,t:"Monitor Server Events",i:0.00201123254686808,a:"The TIBCO Enterprise Message Service server can publish topic messages for internal system events. For example, the server can publish a message when users connect or disconnect. \n   System event messages contain detail about the event stored in properties of the message. This section gives an ..."},"737":{y:0,u:"../users-guide/system-monitor-topic.htm",l:-1,t:"System Monitor Topics",i:0.000227983329142783,a:"The TIBCO Enterprise Message Service server can publish messages to various topics when certain events occur. There are several types of event classes, each class groups a set of related events. For example, some event classes are connection, admin, and route. Each event class is further subdivided ..."},"738":{y:0,u:"../users-guide/monitor-messages.htm",l:-1,t:"Monitor Messages",i:0.000421771997403274,a:"You can monitor messages processed by a destination as they are sent, received, or acknowledged. \n   You can also monitor messages that have prematurely exited due to expiration, being discarded, or a \n\t\t maxRedelivery failure. \n\t  The \n\t\t$sys.monitor topic for monitor messages has the following ..."},"739":{y:0,u:"../users-guide/message-monitoring-q.htm",l:-1,t:"Message monitoring qualifiers",i:0.000227983329142783,a:"Possible values of \n\t D and \n\t E in message monitoring topics. \n   For example, \n\t\t  $sys.monitor.T.r.corp.News is the topic for monitoring any received messages to the topic named \n\t\t  corp.News. The message body of any received message is included in monitor messages on this topic. The topic \n\t\t  ..."},"740":{y:0,u:"../users-guide/description-of-monit.htm",l:-1,t:"Description of Monitor Topics",i:0.000227983329142783,a:"Description of Monitor Topics"},"741":{y:0,u:"../users-guide/description-of-topic.htm",l:-1,t:"Description of Topic Message Properties",i:0.00151640870430473,a:"Each monitor message can have a different set of these properties. \n   Event Action Property Values Event Action Value \n\t\t\t  Description \n\t\t\t  accept connection accepted \n\t\t\t  acknowledge message is acknowledged \n\t\t\t  add user added to a group \n\t\t\t  admin_commit administrator manually committed an ..."},"742":{y:0,u:"../users-guide/view-monitor-topics.htm",l:-1,t:"View Monitor Topics",i:0.000227983329142783,a:"Monitor topics are similar to other topics. To view these topics, create a client application that subscribes to the desired topics. \n   Because monitor topics contain potentially sensitive system information, authentication and permissions are always checked when clients access a monitor topic. ..."},"743":{y:0,u:"../users-guide/performance-implicat.htm",l:-1,t:"Performance Implications of Monitor Topics",i:0.00029257955189628,a:"The TIBCO Enterprise Message Service server only generates messages for monitor topics that currently have subscribers. So, if no applications subscribe to monitor topics, no monitor messages are generated. Generating a monitor message does consume system resources, and therefore you should consider ..."},"744":{y:0,u:"../users-guide/server-statistics.htm",l:-1,t:"Server Statistics",i:0.000586495318401232,a:"The TIBCO Enterprise Message Service server allows you to track incoming and outgoing message volume, message size, and message statistics for the server overall as well as for each producer, consumer, or route. You can configure the type of statistics collected, the interval for computing averages, ..."},"745":{y:0,u:"../users-guide/overall-server-stati.htm",l:-1,t:"Overall Server Statistics",i:0.000227983329142783,a:"The server always collects certain overall server statistics. This includes the rate of inbound and outbound messages (expressed as number of messages per second), message memory usage, disk storage usage, and the number of destinations, connections, and durable subscriptions. Gathering this ..."},"746":{y:0,u:"../users-guide/enable-statistics-ga.htm",l:-1,t:"Enable Statistics Gathering",i:0.000227983329142783,a:"Each producer, consumer, destination, and route can gather overall statistics and statistics for each of its destinations. To enable statistic gathering, you must set the \n\t statistics parameter to enabled. This parameter can be specified in the configuration file, and it can be changed dynamically ..."},"747":{y:0,u:"../users-guide/detailed-statistics.htm",l:-1,t:"Detailed Statistics",i:0.000227983329142783,a:"In some situations, the default statistic gathering may not be sufficient. For example, if a topic subscriber subscribes to wildcard topics, the total statistics for all topics that match the wildcard are kept. You may wish to get further detail in this case and track the statistics for each actual ..."},"748":{y:0,u:"../users-guide/display-the-statisti.htm",l:-1,t:"Display the Statistics",i:0.000227983329142783,a:"When statistic collecting is enabled, you can view statistics for producers, consumers, routes, and destinations using the \n\t show stat command in the administration tool. \n   The \n\t\tshow stat command allows you to filter the statistics based on destination name, user name, connection ID, or any ..."},"749":{y:0,u:"../users-guide/tls-protocol.htm",l:-1,t:"TLS Protocol",i:0.00759432496843746,a:" Transport Layer Security (TLS) is a protocol that provides secure authentication and transmits encrypted data over the Internet or an internal network. \n   The TLS protocol is complex, and this chapter is not a complete description of TLS. Instead, this chapter describes how to configure TLS in the ..."},"750":{y:0,u:"../users-guide/tls-support-in-tibco.htm",l:-1,t:"TLS Support in TIBCO Enterprise Message Service",i:0.000227983329142783,a:"TIBCO Enterprise Message Service supports the Transport Layer Security (TLS) protocol. \n   TLS uses public and private keys to encrypt data over a network connection to secure communication between pairs of components: \n\t  between an EMS client and the \n\t\t  tibemsd server \n\t\t  between the \n\t\t  ..."},"751":{y:0,u:"../users-guide/implementations.htm",l:-1,t:"Implementations",i:0.000227983329142783,a:"The TIBCO Enterprise Message Service server and the C client libraries use OpenSSL for TLS support. \n   For more information, see \n\t\t www.openssl.org . \n\t  EMS Java clients use JSSE (from Sun JavaSoft). JSSE is included in Java distributions. \n\t  EMS .NET Framework clients use the Microsoft ..."},"752":{y:0,u:"../users-guide/digital-certificates.htm",l:-1,t:"Digital Certificates",i:0.000227983329142783,a:"Digital certificates are data structures that represent identities. EMS uses certificates to verify the identities of servers and clients. Though it is not necessary to validate either the server or the client for them to exchange data over TLS, certificates provide an additional level of security.\n ..."},"753":{y:0,u:"../users-guide/digital-certificate-.htm",l:-1,t:"Digital Certificate File Formats",i:0.000227983329142783,a:"Digital Certificate File Formats TIBCO Enterprise Message Service supports the following file formats for digital certificates: PEM (Privacy Enhanced Mail) DER (Distinguished Encoding Rules) PKCS#7 PKCS#12 Java KeyStore (for client digital certificates)"},"754":{y:0,u:"../users-guide/private-key-formats.htm",l:-1,t:"Private Key Formats",i:0.000227983329142783,a:"Private Key Formats TIBCO Enterprise Message Service supports the following file formats for private keys: PEM (Privacy Enhanced Mail) DER (Distinguished Encoding Rules) PKCS#8 PKCS#12 The EMS server uses OpenSSL to read private keys. It does not read Java KeyStore files."},"755":{y:0,u:"../users-guide/file-names-for-certi.htm",l:-1,t:"File Names for Certificates and Keys",i:0.00255683345892885,a:"For all parameters that specify the identity (digital certificate), private key, issuer (certificate chain), or trusted list of certificate authorities, valid files must be specified. Not all types of files are supported for clients and servers. The description of each parameter details which ..."},"756":{y:0,u:"../users-guide/configure-tls-in-the.htm",l:-1,t:"Configure TLS in the Server",i:0.000227983329142783,a:"To use TLS, each instance of \n\t tibemsd must have a digital certificate and a private key. The server can optionally require a certificate chain or trusted certificates. \n   Set the server to listen for TLS connections from clients by using the \n\t\tlisten parameter in \n\t\t tibemsd.conf. To specify ..."},"757":{y:0,u:"../users-guide/tls-parameters.htm",l:-1,t:"TLS Parameters",i:0.000227983329142783,a:"Several TLS parameters can be set in \n\t\ttibemsd.conf. The minimum configuration is only one required parameter—ssl_server_identity. However, if the server’s certificate file does not contain its private key, then you must specify it in \n\t\tssl_server_key. \n\t  TLS Server Parameters  provides a ..."},"758":{y:0,u:"../users-guide/command-line-options.htm",l:-1,t:"Command Line Options",i:0.000227983329142783,a:"The server accepts a few command-line options for TLS. \n   When starting \n\t\ttibemsd, you can specify the following options: \n\t  -ssl_trace—enables tracing of loaded certificates. This prints a message to the console during startup of the server that describes each loaded certificate. \n\t\t ..."},"759":{y:0,u:"../users-guide/configure-https-in-the.htm",l:-1,t:"Configure TLS in the Server",i:0.000629579302612306,a:"Configure HTTPS in the Server You can configure TIBCO Enterprise Message Service to provide health checks and Prometheus-formatted metrics over an HTTP(S) listen port. For more information about this feature, refer to  the  Server Health and Metrics . To use HTTPS, each instance of tibemsd must have ..."},"760":{y:0,u:"../users-guide/configure-tls-in-ems.htm",l:-1,t:"Configure TLS in EMS Clients",i:0.000759683248547611,a:"In basic TLS connections to the EMS server, with standard ciphers, EMS Java clients require no additional libraries or JAR files. The use of ciphers that use stronger encryption may require the installation of the Java Cryptography Extension (JCE) Unlimited Strength Jurisdiction Policy Files into ..."},"761":{y:0,u:"../users-guide/client-digital-certi.htm",l:-1,t:"Client Digital Certificates",i:0.000227983329142783,a:"When client authentication with a digital certificate is required by the EMS server (see the description of the \n\t\tssl_require_client_cert parameter in \n\t\t tibemsd.conf ), the client may combine its client certificate and private key in a single file in one of the following formats: \n\t  PKCS#12 \n\t\t ..."},"762":{y:0,u:"../users-guide/configure-tls.htm",l:-1,t:"Configure TLS",i:0.000227983329142783,a:"A client connecting to an EMS server can configure TLS characteristics in the following ways: \n   Create a connection factory that specifies the appropriate TLS parameters and use JNDI to lookup the connection factory. The server URL in the connection factory must specify the TLS protocol, and the ..."},"763":{y:0,u:"../users-guide/configure-a-connecti.htm",l:-1,t:"Configure a Connection Factory",i:0.00171939199899439,a:"You can configure a connection factory using the administration tool or the administration APIs. \n   See \n\t\t EMS Administration Tool . \n\t  When configuring a connection factory, you can specify several TLS parameters, similar to the server parameters that you can configure in \n\t\t tibemsd.conf . \n\t  ..."},"764":{y:0,u:"../users-guide/specify-cipher-suite.htm",l:-1,t:"Specify Cipher Suites",i:0.00105596836424809,a:"On the EMS server, specify cipher suites using the \n\t ssl_server_ciphers configuration parameter in \n\t tibemsd.conf. \n   For more information about server configuration files, see \n\t\t Configuration Files . \n\t  For clients connecting with a connection factory, specify cipher suites using the \n\t\t ..."},"765":{y:0,u:"../users-guide/syntax-for-cipher-su.htm",l:-1,t:"Syntax for Cipher Suites",i:0.000227983329142783,a:"EMS uses OpenSSL for TLS support. Therefore, the cipher suite names can be specified as the OpenSSL name for the cipher suite.\n   When specifying cipher suites, the usual way to specify more than one cipher suite is to separate each suite name with a colon (:) character. Alternatively, you can use ..."},"766":{y:0,u:"../users-guide/java-client-syntax.htm",l:-1,t:"Java Client Syntax",i:0.000227983329142783,a:"The syntax for specifying the list of cipher suites is different for Java clients than for any other location where cipher suites can be specified. For Java clients, you specify a qualifier (for example, + to add the suite) followed by the cipher suite name. Cipher suite names are case-sensitive. ..."},"767":{y:0,u:"../users-guide/syntax-for-all-other.htm",l:-1,t:"Syntax for All Other Cipher Suite Specifications",i:0.000227983329142783,a:"For any cipher suite list that is not specified in a connection factory of a Java client, use the OpenSSL syntax. In particular, C clients and the \n\t ssl_server_ciphers configuration parameter require OpenSSL syntax. \n   While the full syntax of OpenSSL cipher suite selection is supported for ..."},"768":{y:0,u:"../users-guide/default-cipher-list.htm",l:-1,t:"Default Cipher List",i:0.000227983329142783,a:"Default Cipher List The EMS server and C client library use \n\t DEFAULT as their default cipher list. For details on the cipher suites corresponding to \n\t DEFAULT for a given version of OpenSSL, refer to the OpenSSL documentation. \n  "},"769":{y:0,u:"../users-guide/supported-cipher-sui3.htm",l:-1,t:"Supported Cipher Suites",i:0.000227983329142783,a:"For a current list of supported cipher suites, run the \n\t\thelp ciphers command in the \n\t\ttibemsadmin in tool. \n\t  Note that this list is only relevant to the release of \n\t\tTIBCO Enterprise Message Service that ships with the particular version of \n\t\ttibemsadmin that is running when the help command ..."},"770":{y:0,u:"../users-guide/supported-cipher-sui2.htm",l:-1,t:"Supported Cipher Suites for the Server and C Clients",i:0.000227983329142783,a:"Supported Cipher Suites for the Server and C Clients The EMS server and C client library support a subset of the cipher suites that OpenSSL supports. \n  "},"771":{y:0,u:"../users-guide/supported-cipher-sui4.htm",l:-1,t:"Supported Cipher Suites for Java Clients",i:0.000227983329142783,a:"For Java clients, restrictions apply to some of the newer cipher suites. Using these may require adjustments to some of the following: JVM version, JVM vendor, JCE unlimited strength jurisdiction policy files, the \n\t\tjava.security properties file and X509 certificate digital signature algorithms. \n\t ..."},"772":{y:0,u:"../users-guide/supported-cipher-sui.htm",l:-1,t:"Supported Cipher Suites for .NET Clients",i:0.000227983329142783,a:"Supported Cipher Suites for .NET Clients In general, the .NET client library supports the cipher suites that .NET supports. Refer to your MSDN documentation or contact Microsoft support for complete details on supported ciphers on specific .NET environments. \n\t "},"773":{y:0,u:"../users-guide/tls-authentication-o.htm",l:-1,t:"TLS Authentication Only",i:0.000941809770961234,a:"TLS Authentication Only EMS servers can use TLS for secure data exchange (standard usage), or only for client authentication. This section describes the use of TLS for client authentication.\n  "},"774":{y:0,u:"../users-guide/motivation.htm",l:-1,t:"Motivation",i:0.000227983329142783,a:"Some applications require strong or encrypted authentication, but do not require message encryption.\n   In this situation, application architects could configure TLS with a null cipher. However, this solution incurs internal overhead costs of TLS calls, decreasing message speed and throughput.\n\t  ..."},"775":{y:0,u:"../users-guide/preconditions.htm",l:-1,t:"Preconditions",i:0.000227983329142783,a:"All the following preconditions must be satisfied to use TLS only for authentication: \n   The server must explicitly enable the parameter \n\t\t  ssl_auth_only in the \n\t\t   tibemsd.conf  configuration file. \n\t\t The client program must request a connection that uses TLS for authentication only. Clients ..."},"776":{y:0,u:"../users-guide/enable-fips-complian.htm",l:-1,t:"Enable FIPS Compliance",i:0.000483706786867271,a:"Enable FIPS Compliance You can enable TIBCO Enterprise Message Service to run in compliance with Federal Information Processing Standard (FIPS), Publication 140-2."},"777":{y:0,u:"../users-guide/enable-the-ems-serve.htm",l:-1,t:"Enable the EMS Server",i:0.000227983329142783,a:"\n            The EMS server supports FIPS compliance only on the Linux and Windows platforms. \n\t  To enable FIPS 140-2 operations in the EMS server: \n\t  Set the \n\t\t   fips140-2 parameter in the main configuration file to \n\t\t  true. \n\t\t Ensure that incompatible parameters, listed below, are not ..."},"778":{y:0,u:"../users-guide/enable-ems-clients.htm",l:-1,t:"Enable EMS Clients",i:0.000227983329142783,a:"Java and C client applications can operate in FIPS compliance: \n   Java Clients  Java clients that use the Bouncy Castle FIPS provider can operate in FIPS 140-2 compliant mode. To do so, perform both of the following:\n Set the TLS vendor to bcfips before calling any other EMS methods; refer to the ..."},"779":{y:0,u:"../users-guide/fault-tolerance2.htm",l:-1,t:"Fault Tolerance",i:0.000905561849942403,a:"Fault Tolerance The following sections describe the fault tolerance features of TIBCO Enterprise Message Service. \n  "},"780":{y:0,u:"../users-guide/fault-tolerance-over.htm",l:-1,t:"Fault Tolerance Overview",i:0.000227983329142783,a:"You can arrange TIBCO Enterprise Message Service servers for fault-tolerant operation by configuring a pair of servers—one primary and one secondary. \n   Upon startup, the first server to start reaches the active state and the other the standby state. The active server accepts client connections, ..."},"781":{y:0,u:"../users-guide/shared-state3.htm",l:-1,t:"Shared State",i:0.000227983329142783,a:"A pair of fault-tolerant servers can have access to shared state, which consists of information about clients and persistent messages. \n   \n             You cannot use more than two servers in a fault-tolerant configuration. \n\t  This information enables the standby server to properly assume ..."},"782":{y:0,u:"../users-guide/unshared-state-failo2.htm",l:-1,t:"Unshared State Failover",i:0.000227983329142783,a:"You can also include additional servers that do not share state. As with shared state, the clients can automatically reconnect to additional servers. \n   However, unlike shared state, unshared state is controlled by the EMS client. As a result, it is up to client producers to catch failures on send ..."},"783":{y:0,u:"../users-guide/shared-state-failove.htm",l:-1,t:"Shared State Failover Process",i:0.000324877663273029,a:"Shared State Failover Process This section presents details of the shared state failover sequence."},"784":{y:0,u:"../users-guide/detection.htm",l:-1,t:"Detection",i:0.000227983329142783,a:"A standby server detects a failure of the active server in either of the following ways: Heartbeat Failure or Connection Failure.\n   Heartbeat Failure—The active server sends heartbeat messages to the standby server to indicate that it is still operating. When a network failure stops the servers ..."},"785":{y:0,u:"../users-guide/response2.htm",l:-1,t:"Response",i:0.000227983329142783,a:"Response When a standby server (B) detects the failure of the active server (A), then B attempts to assume the role of active server. First, B obtains the lock on the current shared state. When B can access this information, it becomes the new active server. \n  "},"786":{y:0,u:"../users-guide/lock-unavailable.htm",l:-1,t:"Lock Unavailable",i:0.000227983329142783,a:"Lock Unavailable If B cannot obtain the lock immediately, it alternates between attempting to obtain the lock (and become the active server), and attempting to reconnect to A (and resume as a standby server)—until one of these attempts succeeds."},"787":{y:0,u:"../users-guide/role-reversal.htm",l:-1,t:"Role Reversal",i:0.000227983329142783,a:"Role Reversal When B becomes the new active server, A can restart as a standby server, so that the two servers exchange roles. \n  "},"788":{y:0,u:"../users-guide/client-transfer.htm",l:-1,t:"Client Transfer",i:0.000227983329142783,a:"Client Transfer Clients of A that are configured to failover to standby server B automatically transfer to B when it becomes the new active server. B reads the client’s current state from the shared storage to deliver any persistent messages to the client."},"789":{y:0,u:"../users-guide/client-notification.htm",l:-1,t:"Client Notification",i:0.000227983329142783,a:"Client applications can receive notification when shared state failover occurs. \n   Java \n\t\t   To receive notification, Java client programs set the system property \n\t\t\t tibco.tibjms.ft.switch.exception to any value, and define an \n\t\t\t ExceptionListener to handle failover notification; see the class ..."},"790":{y:0,u:"../users-guide/message-redelivery.htm",l:-1,t:"Message Redelivery",i:0.000421771997403274,a:"Qualified messages will be redelivered in a failover situation. \n   Persistent \n\t\t   When a failure occurs, messages with delivery mode \n\t\t\t PERSISTENT, that were not successfully acknowledged before the failure, are redelivered. \n\t\t   Synchronous Mode \n\t\t   When using durable subscribers, EMS ..."},"791":{y:0,u:"../users-guide/transactions2.htm",l:-1,t:"Transactions",i:0.000227983329142783,a:"A (non-XA) transaction is considered active when at least one message has been sent or received by the session, and the transaction has not been successfully committed. An XA transaction is considered active when the XA start method is called.\n   After a failover, attempting to commit the active ..."},"792":{y:0,u:"../users-guide/queues.htm",l:-1,t:"Queues",i:0.000227983329142783,a:"For queue receivers, any messages that have been sent to receivers, but have not been acknowledged before the failover, may be sent to other receivers immediately after the failover.\n   A receiver trying to acknowledge a message after a failover may receive the \n\t\tjavax.jms.IllegalStateException. ..."},"793":{y:0,u:"../users-guide/heartbeat-parameters.htm",l:-1,t:"Heartbeat Parameters",i:0.000421771997403274,a:"When the active server heartbeat stops, the standby server waits for its activation interval (elapsed time since it detected the most recent heartbeat); then the standby server retrieves information from shared storage and assumes the role of active server. The default heartbeat interval is 3 ..."},"794":{y:0,u:"../users-guide/configuration-files.htm",l:-1,t:"Configuration Files",i:0.000227983329142783,a:"When an active server fails, its standby server assumes the status of the active server and resumes operation. Before becoming the active server, the standby server re-reads its configuration files.\n   If the two servers share configuration files, then the administrative changes to an active server ..."},"795":{y:0,u:"../users-guide/unshared-state-failo.htm",l:-1,t:"Unshared State Failover Process",i:0.000401982618750956,a:"Unshared State Failover Process The following topics detail the unshared state failover sequence of events. \n   To configure clients, see \n\t\t Configure Clients for Unshared State Failover Connections . \n\t "},"796":{y:0,u:"../users-guide/detection2.htm",l:-1,t:"Detection",i:0.000227983329142783,a:"Unshared state failover is initiated by the EMS client. When a client setup for unshared state detects a lost connection to server (A), it attempts to connect to server (B), as defined in the connection factory. \n   \n                Unshared state is not limited to two servers. Unlike shared state ..."},"797":{y:0,u:"../users-guide/response.htm",l:-1,t:"Response",i:0.000227983329142783,a:"Clients with unshared state connections automatically connect to B after losing the connection to A. When clients setup for unshared state detect lost connections to server A, they create new connections to server B. All runtime objects from the client\u0027s connection are recreated, including sessions, ..."},"798":{y:0,u:"../users-guide/message-loss.htm",l:-1,t:"Message Loss",i:0.000227983329142783,a:"Message Loss Because B does not have access to persistent messages that were not delivered or acknowledged prior to the failover, some messages may be lost or delivered out of order across the failover process. To prevent message loss, use shared state failover."},"799":{y:0,u:"../users-guide/unsupported-features.htm",l:-1,t:"Unsupported Features",i:0.000227983329142783,a:"Unsupported Features These features and Java classes are not supported with unshared state connections: XA transactions Durable topic subscribers ConnectionConsumer ServerSession ServerSessionPool QueueRequestor TopicRequestor"},"800":{y:0,u:"../users-guide/dual-state-failover.htm",l:-1,t:"Dual State Failover",i:0.000227983329142783,a:"An unshared state connection factory can include shared-state server pairs in its list of backup servers. When both shared state and unshared state servers are included, the failover process is a combination of both types of failover. \n   The following image illustrates the dual state failover ..."},"801":{y:0,u:"../users-guide/shared-state.htm",l:-1,t:"Shared State",i:0.000700630409919592,a:"For the most robust failover protection, the active server and standby server must share the same state. Shared state includes the following categories of information: persistent message data (for queues and topics) client connections of the active server metadata about message delivery During a ..."},"802":{y:0,u:"../users-guide/implement-shared-sta.htm",l:-1,t:"Implement Shared State",i:0.000227983329142783,a:"If using file-based stores, we recommend that you implement shared state using shared storage devices. The shared state must be accessible to both the active and standby servers. If using grid stores or FTL stores, shared state is provided by the ActiveSpaces or FTL deployment.\n  "},"803":{y:0,u:"../users-guide/support-criteria.htm",l:-1,t:"Support Criteria",i:0.00360031899656249,a:"If your stores are file-based, there are several options available for implementing shared storage, using a combination of hardware and software. EMS requires that your storage solution guarantees the following listed criteria. \n   Always consult your shared storage vendor and your operating system ..."},"804":{y:0,u:"../users-guide/hardware-options.htm",l:-1,t:"Hardware Options",i:0.000227983329142783,a:"Hardware Options Consider these examples of commonly-sold hardware options for shared storage: Dual-Port SCSI device Storage Area Network (SAN) Network Attached Storage (NAS)"},"805":{y:0,u:"../users-guide/scsi-and-san.htm",l:-1,t:"SCSI and SAN",i:0.000227983329142783,a:"SCSI and SAN Dual-port SCSI and SAN solutions generally satisfy the  Write Order  and  Synchronous Write Persistence  criteria. (The clustering software must satisfy the remaining two criteria.) As always, you must confirm all four requirements with your vendors."},"806":{y:0,u:"../users-guide/nas.htm",l:-1,t:"NAS",i:0.000227983329142783,a:"NAS NAS solutions require a CS (rather than a CFS) to satisfy the  Distributed File Locking  criterion (see below). Some NAS solutions satisfy the criteria, and some do not; you must confirm all four requirements with your vendors."},"807":{y:0,u:"../users-guide/nas-with-nfs.htm",l:-1,t:"NAS with NFS",i:0.000227983329142783,a:"When NAS hardware uses NFS as its file system, it is particularly difficult to determine whether the solution meets the criteria. Our research indicates the following conclusions: \n   NFS v2 and NFS v3 definitely do \n\t\t  not satisfy the criteria. \n\t\t NFS v4 with TCP \n\t\t  might satisfy the criteria. ..."},"808":{y:0,u:"../users-guide/software-options.htm",l:-1,t:"Software Options",i:0.00329777453753279,a:"Consider these examples of commonly-sold software options: Cluster Server (CS) A cluster server monitors the EMS server processes and their host computers, and ensures that exactly one server process is running at all times. If that server fails, the CS restarts it; if the CS fails to restart it, it ..."},"809":{y:0,u:"../users-guide/messages-stored-in-s.htm",l:-1,t:"Messages Stored in Shared State",i:0.000227983329142783,a:"Messages with \n\t PERSISTENT delivery mode are stored, and are available in the event of active server failure. Messages with \n\t NON_PERSISTENT \n\t delivery mode are not available if the active server fails.\n   For more information about recovery of messages during failover, see \n\t\t Message Redelivery ..."},"810":{y:0,u:"../users-guide/storage-files.htm",l:-1,t:"Storage Files",i:0.000227983329142783,a:"Shared State Storage By default, the \n\t tibemsd server creates three  stores to store shared state. \n   $sys.failsafe—This store holds persistent messages using synchronous I/O calls. \n\t\t $sys.nonfailsafe—This store stores messages using asynchronous I/O calls. \n\t\t $sys.meta—This store holds state ..."},"811":{y:0,u:"../users-guide/configure-fault-tole.htm",l:-1,t:"Configure Fault-Tolerant Servers",i:0.000227983329142783,a:"Configure Fault-Tolerant Servers The following topics describe how to configure fault-tolerant servers, for the shared state and the unshared state scenarios. \n  "},"812":{y:0,u:"../users-guide/shared-state2.htm",l:-1,t:"Shared State",i:0.000227983329142783,a:"To configure an EMS server as a fault-tolerant secondary when using file-based stores or grid stores, set the below parameters in its main configuration file (or on the server command line). The primary and secondary roles cannot be explicitly defined when using FTL stores.\n   server    Set this ..."},"813":{y:0,u:"../users-guide/authorization-and-fa.htm",l:-1,t:"Authorization and Fault-Tolerant Servers",i:0.000452739392135273,a:"Authentication and Authorization for Fault-Tolerant Servers Authentication and authorization for fault-tolerance is configured through FTL when the EMS servers are using FTL stores. See  Configuring and Deploying FTL Stores  for details. EMS authentication and authorization interact with fault ..."},"814":{y:0,u:"../users-guide/User-_-Password.htm",l:-1,t:"Authorization and Fault-Tolerant Servers",i:0.000227983329142783,a:"User \u0026 Password When using user credential based authentication (see the local or jaas Authentication Methods ), a server will authenticate its fault-tolerant peer server by validating the user name and password provided as part of the connection request from the peer server. This following files ..."},"815":{y:0,u:"../users-guide/OAuth_2.0.htm",l:-1,t:"Authorization and Fault-Tolerant Servers",i:0.000227983329142783,a:"OAuth 2.0 When using oauth2 authentication (see  Authentication Methods ) the EMS server will authenticate its fault-tolerant peer server by validating an OAuth 2.0 access token received as part of the peer server’s connection request. For OAuth 2.0 authentication to be successful between ..."},"816":{y:0,u:"../users-guide/tls.htm",l:-1,t:"TLS",i:0.000379975198192464,a:"TLS security for fault-tolerance related communication is configured through FTL when using FTL stores. See  Configuring and Deploying FTL Stores  for details. You can use TLS to secure communication between a pair of fault-tolerant servers. \n   Parameters in the main configuration file ( ..."},"817":{y:0,u:"../users-guide/reconnect-timeout.htm",l:-1,t:"Reconnect Timeout",i:0.000227983329142783,a:"When a standby server assumes the role of the active server during failover, clients attempt to reconnect to the standby server (that is, the new active) and continue processing their current message state. Before accepting reconnects from the clients, the new active server reads its message state ..."},"818":{y:0,u:"../users-guide/unshared-state.htm",l:-1,t:"Unshared State",i:0.000227983329142783,a:"When configuring a fault tolerant pair that does not share state, you must ensure that both servers use identical configurations.\n   This is especially important for these configuration settings:\n\t  Destinations\n\t\t\t\t   Both servers must support the same destinations.\n\t\t\t\t Routes\n\t\t\t\t   Messages must ..."},"819":{y:0,u:"../users-guide/fault-tolerance-with.htm",l:-1,t:"Fault Tolerance with a JSON Configuration",i:0.000227983329142783,a:"This section is only applicable when using file-based stores or grid stores. To configure fault-tolerance when using FTL stores, see the  Fault-Tolerance with FTL Stores  and  Configuring and Deploying FTL Stores  sections. When using a JSON configuration, the same JSON file is used to manage both ..."},"820":{y:0,u:"../users-guide/configuring-fault-to.htm",l:-1,t:"Configuring Fault Tolerance",i:0.000227983329142783,a:"Configuring Fault Tolerance  To configure a fault tolerant server pair using a JSON configuration, refer to the \n\t\t TIBCO Messaging Manager  documentation.\n\t "},"821":{y:0,u:"../users-guide/configuration-errors.htm",l:-1,t:"Configuration Errors",i:0.000227983329142783,a:"When an EMS server is started, the fault tolerance mechanism is triggered by the presence of a URL in the \"secondary_listens\" node of a primary tibemsd, or by that of a URL in the \"primary_listens\" node of a secondary \n\t tibemsd. \n   Once fault tolerance is triggered, the EMS server generates an ..."},"822":{y:0,u:"../users-guide/configure-clients-fo2.htm",l:-1,t:"Configure Clients for Shared State Failover Connections",i:0.00144363980136276,a:"When a failover occurs and the standby server takes the active state, clients attempt to reconnect to this server (that is, the new active server). To enable a client to reconnect, you must specify the URLs of both servers when creating a connection.\n   Specify multiple servers as a comma-separated ..."},"823":{y:0,u:"../users-guide/specify-more-than-tw.htm",l:-1,t:"Specify More Than Two URLs",i:0.000227983329142783,a:"Even though there are only two servers (the primary and secondary servers), clients can specify more than two URLs for the connection. For example, if each server has more than one listen address, a client can reconnect to the same server at a different address (that is, at a different network ..."},"824":{y:0,u:"../users-guide/set-reconnection-fai.htm",l:-1,t:"Set Reconnection Failure Parameters",i:0.0024167823423553,a:"EMS allows you to establish separate parameters for initial connection attempts and reconnection attempts. \n   How to set the initial connection attempt parameters is described in \n\t\t Set Connection Attempts, Timeout and Delay Parameters . This section describes the parameters you can establish for ..."},"825":{y:0,u:"../users-guide/configure-clients-fo.htm",l:-1,t:"Configure Clients for Unshared State Failover Connections",i:0.000569674713498069,a:"\n            Unshared state failover is an extension of the Jakarta Messaging specification. Because state is not shared among servers, messages can be lost, duplicated, or delivered out-of-order across the failover process. \n\t  Unshared state connections are created differently from shared state ..."},"826":{y:0,u:"../users-guide/include-the-unshared.htm",l:-1,t:"Include the Unshared State Library",i:0.000227983329142783,a:"Java Applications \n\t\t   Before creating the connection factory, ensure that the \n\t\t\t CLASSPATH includes the JAR file: tibjmsufo.jar C Applications \n\t\t   Include the \n\t\t\t tibemsufo.h header file. \n\t\t   C# Applications \n\t\t   Include the \n\t\t\t TIBCO.EMS.UFO.dll file. \n\t\t  "},"827":{y:0,u:"../users-guide/create-an-unshared-s.htm",l:-1,t:"Create an Unshared State Connection Factory",i:0.000227983329142783,a:"To create unshared state connections, use the relevant methods:\n   Java Applications\n\t\t   java com.tibco.tibems.ufo package.\n\t\t   C Applications\n\t\t   tibemsufo library and functions.\n\t\t   C# Applications\n\t\t   TIBCO.EMS.UFO package.\n\t\t   Methods called inside a MessageListener callback immediately ..."},"828":{y:0,u:"../users-guide/connection-recovery.htm",l:-1,t:"Connection Recovery",i:0.000227983329142783,a:"When an unshared state connection fails, the connection’s \n\t\tExceptionListener callback is invoked. To recover the connection—repair it so that it is connected to an active server—the client application calls the connection factory’s \n\t\t recoverConnection method or ..."},"829":{y:0,u:"../users-guide/specify-server-urls.htm",l:-1,t:"Specify Server URLs",i:0.000227983329142783,a:"When a server connection is lost during an unshared state failover, clients attempt to reconnect to the second server. To enable a client to reconnect, you must specify the URLs of both servers when creating a connection. \n   Unshared State \n\t\t\t\t  Specify multiple servers as a list of URLs separated ..."},"830":{y:0,u:"../users-guide/set-connect-attempt-.htm",l:-1,t:"Set Connect Attempt and Reconnect Attempt Behavior",i:0.000227983329142783,a:"The effect of setting connect attempt and reconnect attempt properties at the application level is different when applied to unshared state connection factories.\n   If the EMS client is using a shared state connection factory, then the values specified by way of properties or API calls will be the ..."},"831":{y:0,u:"../users-guide/routes.htm",l:-1,t:"Routes",i:0.0012773142133837,a:"Routes The following sections describe routing of messages among TIBCO Enterprise Message Service servers. \n  "},"832":{y:0,u:"../users-guide/overview-of-routing.htm",l:-1,t:"Overview",i:0.000227983329142783,a:"TIBCO Enterprise Message Service servers can route messages to other servers. \n   Topic messages can travel one hop or multiple hops (from the first server). \n\t\t Queue messages can travel only one hop to the home queue, and one hop from the home queue. \n\t\t You can define routes using an ..."},"833":{y:0,u:"../users-guide/route.htm",l:-1,t:"Route",i:0.000227983329142783,a:"Route"},"834":{y:0,u:"../users-guide/basic-operation2.htm",l:-1,t:"Basic Operation",i:0.000227983329142783,a:"Each \n\t\t  route connects two TIBCO Enterprise Message Service servers. \n\t\t Each route forwards messages between corresponding destinations (that is, global topics with the same name, or explicitly routed queues) on its two servers. \n\t\t Routes are bidirectional; that is, each server in the pair ..."},"835":{y:0,u:"../users-guide/global-destinations.htm",l:-1,t:"Global Destinations",i:0.000227983329142783,a:"Routes forward messages only between global destinations—that is, for topics the \n\t\tglobal property must be set on both servers (for queues, see \n\t\t Routed Queues ). \n\t  For more information about destination properties, See \n\t\t Destination Properties . \n\t  The following image illustrates a route ..."},"836":{y:0,u:"../users-guide/unique-routing-path.htm",l:-1,t:"Unique Routing Path",i:0.000227983329142783,a:"It is illegal to define a set of routes that permit a message to reach a server by more than one path. TIBCO Enterprise Message Service servers detect illegal duplicate routes and report them as configuration errors. \n   The following image depicts two sets of routes. On the left, the routes ..."},"837":{y:0,u:"../users-guide/zone.htm",l:-1,t:"Zone",i:0.000622859179740549,a:"Zone Zones restrict the behavior of routes, so you can configure complex routing paths. Zones affect topic messages, but not queue messages."},"838":{y:0,u:"../users-guide/basic-operation.htm",l:-1,t:"Basic Operation",i:0.000227983329142783,a:"A \n\t zone is a named set of routes. Every route belongs to a zone. \n   A zone affects the forwarding behavior of its routes: \n\t  In a multi-hop (mhop) zone, topic messages travel along all applicable routes to all servers connected by routes within the zone. \n\t\t In a one-hop (1hop) zone, topic ..."},"839":{y:0,u:"../users-guide/eliminate-redundant-.htm",l:-1,t:"Eliminate Redundant Paths with a One-Hop Zone",i:0.000227983329142783,a:"The following image illustrates an enterprise with four servers: \n\t  B1 and B2 serve producers at branch offices of an enterprise. \n\t\t M serves consumers at the main office, which process the messages from the branches. \n\t\t R serves consumers that record messages for archiving, auditing, and backup. ..."},"840":{y:0,u:"../users-guide/overlapping-zones.htm",l:-1,t:"Overlapping Zones",i:0.000227983329142783,a:"A server can have routes that belong to several zones. When zones overlap at a server, the routing behavior within each zone does not limit routing in other zones. That is, when a forwarded message reaches a server with routes in several zones, the message crosses zone boundaries, and its hop count ..."},"841":{y:0,u:"../users-guide/active-and-passive-r.htm",l:-1,t:"Active and Passive Routes",i:0.000513822106989764,a:"Active and Passive Routes A route connects two servers. You may configure a route at either or both of the servers."},"842":{y:0,u:"../users-guide/active-passive-route.htm",l:-1,t:"Active-Passive Routes",i:0.000227983329142783,a:"When you configure a route at only one server, this asymmetry results in different perspectives on the route. \n   A route is \n\t\t  active from the perspective of the server where it is configured. This server actively initiates the connection to the other server, so we refer to it as the \n\t\t  active ..."},"843":{y:0,u:"../users-guide/active-active-routes.htm",l:-1,t:"Active-Active Routes",i:0.000227983329142783,a:"Two servers can both configure an active route one to the other. This arrangement is called an \n\t active-active configuration. \n   For example, server A specifies a route to server B, and B specifies a route to A. Either server can attempt to initiate the connection. This configuration results in ..."},"844":{y:0,u:"../users-guide/configure-routes-and.htm",l:-1,t:"Configure Routes and Zones",i:0.000811803623457285,a:"You can create routes using the administration tool, or the administration APIs (see \n\t com.tibco.tibjms.admin.RouteInfo in the online documentation). \n   Syntax To create a route using the administration tool, first connect to one of the servers, then use the \n\t\t  create route command with the ..."},"845":{y:0,u:"../users-guide/routes-to-fault-tole.htm",l:-1,t:"Routes to Fault-Tolerant Servers",i:0.000227983329142783,a:"You can configure servers for fault tolerance. Client applications can specify the primary and secondary servers. Once a client has connected to the active server, if its connection to the server fails, the client can connect to the standby server and resume operation. Similarly, a route ..."},"846":{y:0,u:"../users-guide/routing-and-tls.htm",l:-1,t:"Routing and TLS",i:0.000365992644371739,a:"When configuring a route, you can specify TLS parameters for the connection. Although both participants in a TLS connection must specify a similar set of parameters, each server specifies this information in a different place. \n   The passive server must specify TLS parameters in its main ..."},"847":{y:0,u:"../users-guide/tls-parameters-for-r.htm",l:-1,t:"TLS Parameters for Routes",i:0.000429070511480057,a:"The following table lists parameters that you can specify in the \n\t\t   routes.conf configuration file, or on the command line when creating a route. The parameters for configuring TLS between routed servers are similar to the parameters used to configure TLS between server and clients; see \n\t\t   TLS ..."},"848":{y:0,u:"../users-guide/routed-topic-message.htm",l:-1,t:"Routed Topic Messages",i:0.000227983329142783,a:"A server forwards topic messages along routes only when the global property is defined for the topic. \n   Topic messages can traverse multiple hops. \n\t  When a route becomes disconnected (for example, because of network problems), the forwarding server stores topic messages. When the route ..."},"849":{y:0,u:"../users-guide/registered-interest-.htm",l:-1,t:"Registered Interest Propagation",i:0.000227983329142783,a:"To ensure forwarding of messages along routes, servers propagate their topic subscriptions to other servers. \n   For example, the top of the following image depicts an enterprise with three servers—A, M and B—connected by routes in a multi-hop zone. The bottom of the figure illustrates the mechanism ..."},"850":{y:0,u:"../users-guide/selectors-for-routin.htm",l:-1,t:"Selectors for Routing Topic Messages",i:0.000567079826709013,a:"A server forwards a global topic message along routes to all servers with subscribers for that topic. When each of those other servers requires only a small subset of the messages, this policy could potentially result in a high volume of unwanted network traffic. \n\t  You can specify \n\t\tmessage ..."},"851":{y:0,u:"../users-guide/example.htm",l:-1,t:"Example",i:0.000324877663273029,a:"The following figure illustrates an enterprise with a central server for processing customer orders, and separate regional servers for billing those orders. For optimal use of network capacity, we configure topic selectors so that each regional server gets only those orders related to customers ..."},"852":{y:0,u:"../users-guide/specifying-selectors.htm",l:-1,t:"Specifying Selectors",i:0.000227983329142783,a:"Specify message selectors for global topics as properties of routes. You can define these properties in two ways: \n   Define selectors when creating the route (either in \n\t\t\t  routes.conf , or with the administrator command \n\t\t\t create route). \n\t\t   Manipulate selectors on an existing route (using ..."},"853":{y:0,u:"../users-guide/syntax.htm",l:-1,t:"Syntax",i:0.000227983329142783,a:"The message selector properties have the same syntax whether they appear in a command or in a configuration file:  incoming_topic=topicName selector=\"msg-selector\"\n outgoing_topic=topicName selector=\"msg-selector\" \n            The terms incoming and outgoing refer to the perspective of the active ..."},"854":{y:0,u:"../users-guide/example-syntax.htm",l:-1,t:"Example Syntax",i:0.000227983329142783,a:"As described in \n\t\t Example , an administrator might configure these routes on the central order server: \n\t  setprop route Canada outgoing_topic=\"orders\" selector=\"country=\u0027Canada\u0027\"\nsetprop route Mexico outgoing_topic=\"orders\" selector=\"country=\u0027Mexico\u0027\"\nsetprop route USA    outgoing_topic=\"orders\" ..."},"855":{y:0,u:"../users-guide/symmetry.htm",l:-1,t:"Symmetry",i:0.000227983329142783,a:"Symmetry outgoing_topic and \n\t incoming_topic are symmetric. Whether A specifies a route to B with \n\t incoming_topic selectors, or B specifies a route to A with \n\t outgoing_topic \n\t selectors, the effect is the same. That is, B sends only those messages that match the selector over the route.\n  "},"856":{y:0,u:"../users-guide/active-active-config.htm",l:-1,t:"Active-Active Configuration",i:0.000227983329142783,a:"In an active-active configuration, you may specify selectors on either or both servers. If you specify \n\t outgoing_topic \n\t selector S1 for topic T on server A, and \n\t incoming_topic selector S2 for T on server B, then the effective selector for T on the route from A to B is (S1 AND S2).\n   See also ..."},"857":{y:0,u:"../users-guide/wildcards2.htm",l:-1,t:"Wildcards",i:0.000421771997403274,a:"You can specify wildcards in topic names. For each actual topic, the server uses logical AND to combine all the selectors that match the topic.\n   \n            However, routing of topic messages is only reliably supported when the subscriber\u0027s topic is a subset (or equal) of the configured global ..."},"858":{y:0,u:"../users-guide/routed-queues.htm",l:-1,t:"Routed Queues",i:0.000324877663273029,a:"With respect to routing, queues differ from topics in several respects. \n   These differences can be summarized as: \n\t  Servers route queue messages between the queue owner and adjacent servers. \n\t\t The concept of zones and hops does not apply to queue messages (only to topic messages). \n\t\t The left ..."},"859":{y:0,u:"../users-guide/owner-and-home.htm",l:-1,t:"Owner and Home",i:0.000227983329142783,a:"Server R defines a global queue named Q1. R is the owner of Q1. Servers P and S define routed queues Q1@R. This designation indicates that these queues depend upon and reflect their home queue (that is, Q1 on server R). Notice that the designation Q1@R is only for the purpose of configuration; ..."},"860":{y:0,u:"../users-guide/example3.htm",l:-1,t:"Example",i:0.000227983329142783,a:"When J sends a message to Q1, server P forwards the message to the home queue—Q1 on server R. Now the message is available to receivers on all three servers, P, R and S—although only one client can consume the message. Either Q1 on P receives it on behalf of K; or Q1 on S receives it on behalf of N; ..."},"861":{y:0,u:"../users-guide/producers.htm",l:-1,t:"Producers",i:0.000227983329142783,a:"From the perspective of producer clients, a routed queue stores messages and forwards them to the home queue. For example, when J sends a message to Q1 on server P, P forwards it to the queue owner, R, which delivers it to Q1 (the home queue).\n   The message is not available for consumers until it ..."},"862":{y:0,u:"../users-guide/consumers.htm",l:-1,t:"Consumers",i:0.000227983329142783,a:"From the perspective of consumer clients, a routed queue acts as a proxy receiver. For example, when L sends a message to Q1 on server R, Q1 on P can receive it from R on behalf of K, and immediately gives it to K. If server P fails, or the route connection from P to R fails, K cannot receive ..."},"863":{y:0,u:"../users-guide/configuration2.htm",l:-1,t:"Configuration",i:0.000227983329142783,a:"You must explicitly configure each routed queue in \n\t\t queues.conf —clients cannot create routed queues dynamically. \n\t  \n            Dynamic routed queues are not supported. In a future release, the server will consider a routed queue with a wildcard as a misconfiguration and will fail to start ..."},"864":{y:0,u:"../users-guide/browsing.htm",l:-1,t:"Browsing",i:0.000227983329142783,a:"Browsing Queue browsers cannot examine routed queues. That is, you can create a browser only on the server that owns the home queue.\n  "},"865":{y:0,u:"../users-guide/transactions3.htm",l:-1,t:"Transactions",i:0.000227983329142783,a:"Transactions TIBCO Enterprise Message Service does not support transactional consumers on routed queues (through the use of XA or local transacted sessions). \n  "},"866":{y:0,u:"../users-guide/routing-and-authoriz.htm",l:-1,t:"Routing and Authorization",i:0.000605379407407424,a:"Authentication and Authorization for Routes In the above image, servers A and B both configure active routes to one another. This scenario will be used as an example to explain authentication and authorization for routes in the following sections. "},"867":{y:0,u:"../users-guide/authentication.htm",l:-1,t:"ACL",i:0.000365992644371739,a:"Authentication When a server’s authorization parameter is enabled, other servers that actively connect to it must authenticate themselves by user name and password, or by providing an OAuth 2.0 access token, depending on the server\u0027s user_auth parameter (see  Authentication Methods )."},"868":{y:0,u:"../users-guide/User_Password.htm",l:-1,t:"ACL",i:0.000227983329142783,a:"User \u0026 Password When using the local or jaas authentication methods, a server will authenticate other servers connecting to it by validating the user name and password presented by the connecting servers. In the scenario depicted in the image above: Because A enabled authorization: If using local ..."},"869":{y:0,u:"../users-guide/OAuth2.0.htm",l:-1,t:"ACL",i:0.000227983329142783,a:"OAuth 2.0 When using oauth2 authentication, a server will authenticate other servers trying to connect to it by validating the OAuth 2.0 access token presented by the connecting servers. In the scenario depicted in the image above: Because A enabled authorization, B must configure its route to ..."},"870":{y:0,u:"../users-guide/acl.htm",l:-1,t:"ACL",i:0.000227983329142783,a:"When routing a secure topic or queue, servers consult the ACL specification before forwarding each message. The servers must grant one another appropriate permissions to send, receive, publish or subscribe. \n\t  For example, in above image, you don’t need an ACL for messages to flow from A (where a ..."},"871":{y:0,u:"../users-guide/conversion-of-server.htm",l:-1,t:"Conversion of Server Configuration Files to JSON",i:0.00222794820204249,a:"The \n\t tibemsconf2json utility is provided to convert a set of text-based EMS server configuration files into a single JSON configuration file. \n   When using the utility, keep in mind that: \n\t\t If there are any unsupported parameters in the source configuration file, the \n\t\t\t tibemsconf2json ..."},"872":{y:0,u:"../users-guide/monitor-messages2.htm",l:-1,t:"Monitor Messages",i:0.00209527267437633,a:"Monitor Messages This section lists all the topics on which the server publishes messages for system events. The message properties for messages published on each topic are also described.\n   See \n\t\t Monitor Server Events  for more information about monitor topics and messages.\n\t "},"873":{y:0,u:"../users-guide/error-and-status-mes2.htm",l:-1,t:"Error and Status Messages",i:0.000227983329142783,a:"Error and Status Messages This section lists all possible error messages that the server can output, alphabetized by category. \n  "},"874":{y:0,u:"../users-guide/error-and-status-mes.htm",l:-1,t:"Error and Status Codes",i:0.000227983329142783,a:"Authentication error Description The EMS server failed to authenticate the user or password. Resolution Ensure the user is defined to EMS by one of the methods allowed by the user_auth parameter in the main configuration file. The user is either specified by the application or in the TLS ..."},"875":{y:0,u:"../c-and-cobol-reference/introduction.htm",l:-1,t:"Introduction",i:0.000586495318401232,a:"Introduction The following topics present concepts specific to the TIBCO Enterprise Message Service™ C API and COBOL API. For more information, see \n\t TIBCO Enterprise Message Service™ User Guide.  "},"876":{y:0,u:"../c-and-cobol-reference/overview.htm",l:-1,t:"Overview",i:0.000227983329142783,a:"TIBCO Enterprise Message Service Java API implements (and extends) the JMS 2.0 specification. TIBCO Enterprise Message Service C API closely mimics the Java API. EMS COBOL API brings the power of EMS to z/OS systems. Its entry points parallel those of the C API, with identical function names and ..."},"877":{y:0,u:"../c-and-cobol-reference/excluded-features-an.htm",l:-1,t:"Excluded Features and Restrictions",i:0.000227983329142783,a:"Excluded Features and Restrictions This section summarizes features that are not available in either the C library, or the COBOL library.\n  "},"878":{y:0,u:"../c-and-cobol-reference/naming-conventions-a.htm",l:-1,t:"Naming Conventions and Length Limitations",i:0.000227983329142783,a:"Naming Conventions and Length Limitations The rules that govern naming conventions and length limitations in TIBCO Enterprise Message Service are described in the \n\t TIBCO Enterprise Message Service User Guide. \n  "},"879":{y:0,u:"../c-and-cobol-reference/strings-and-characte.htm",l:-1,t:"Strings and Character Encodings",i:0.000913888026969096,a:"Typically, C clients manipulate strings using the character encoding of the machine on which they are running. \n   The EMS C client library itself does not do any encoding or decoding of characters. When sending a message, an EMS C client application can use \n\t\t tibemsMsg_SetEncoding to put ..."},"880":{y:0,u:"../c-and-cobol-reference/ibm-zos-and-ibm-i-i.htm",l:-1,t:"IBM z/OS and IBM i (i5)—COBOL and C",i:0.000227983329142783,a:"In EBCDIC environments, the EMS client library automatically converts message strings. To client programs, all strings appear in the host code page. On the network, all strings appear in the network host page. For details, see \n\t  tibems_SetCodePages() All the COBOL calls documented in this ..."},"881":{y:0,u:"../c-and-cobol-reference/configuring-c-and-co.htm",l:-1,t:"Configuring C and COBOL Clients for Fault-Tolerant Connections",i:0.00110462988243678,a:"When connecting a fault-tolerant client to EMS, you must specify two or more EMS servers. \n   C clients list the primary and backup server URLs in the \n\t\tbrokerURL argument to a connection constructor, separated by a comma. \n\t  Example In this example, the first server is \n\t\ttcp://server0:7222, and ..."},"882":{y:0,u:"../c-and-cobol-reference/messages.htm",l:-1,t:"Messages",i:0.000227983329142783,a:"Messages Message objects carry application data between client program processes. The following topics present the structure of Jakarta Messaging message selector syntax to specify a subset of messages based on their property values, the message types, and their functions.\n  "},"883":{y:0,u:"../c-and-cobol-reference/parts-of-a-message.htm",l:-1,t:"Parts of a Message",i:0.000227983329142783,a:"Messages consist of three parts: \n   Body The body of a message bears the information content of an application. Several types of message body organize that information in different ways; see \n\t\t\t\t Body Types . \n\t\t\t  Header Headers associate a fixed set of header field names with values. Clients and ..."},"884":{y:0,u:"../c-and-cobol-reference/body-types.htm",l:-1,t:"Body Types",i:0.00068196169396657,a:"EMS follows Jakarta Messaging in defining five types of message body: \n   tibemsMapMsg  \n\t\t   The message body is a mapping from field names to values. Field names are strings. EMS supports an extended set of values types (extending Jakarta Messaging). Programs can access fields either by name, or ..."},"885":{y:0,u:"../c-and-cobol-reference/headers.htm",l:-1,t:"Headers",i:0.000573510386709464,a:"Jakarta Messaging Message headers associate a fixed set of header field names with values. Clients and providers use headers to identify and route messages. \n   Programs can access header values using the function calls in the following table. \n\t\t However, programs can effectively set only three ..."},"886":{y:0,u:"../c-and-cobol-reference/properties.htm",l:-1,t:"Properties",i:0.000227983329142783,a:"Properties Properties associate an extensible set of property field names with values. The EMS server uses properties to attach ancillary information to messages. Client applications can also use properties—for example, to customize message filtering; see  Message Selectors ."},"887":{y:0,u:"../c-and-cobol-reference/setting-message-prop.htm",l:-1,t:"Set Message Properties",i:0.000227983329142783,a:"Property names must conform to the syntax for message selector identifiers. \n   For more information on the syntax, see \n\t\t Identifiers . \n\t  Property values cannot be null or an empty string. \n\t  Sending programs can set property values before sending a message. \n\t  Receiving programs cannot ..."},"888":{y:0,u:"../c-and-cobol-reference/ems-properties.htm",l:-1,t:"EMS Properties",i:0.00728565243469031,a:"The Jakarta Messaging specification reserves the property name prefix JMS_vendor_name_ for provider-specific properties (for EMS, this prefix is \n\t JMS_TIBCO_). Properties that begin with this prefix refer to features of EMS; client programs may use these properties to access those features, but not ..."},"889":{y:0,u:"../c-and-cobol-reference/jms-properties.htm",l:-1,t:"JMS Properties",i:0.000227983329142783,a:"Jakarta Messaging Properties The Jakarta Messaging specification reserves the property name prefix \n\t JMSX for properties defined by Jakarta Messaging. Client programs may use these properties to access those features, but not for communicating application-specific information among client ..."},"890":{y:0,u:"../c-and-cobol-reference/message-selectors.htm",l:-1,t:"Message Selectors",i:0.00782038030026017,a:"A message selector is string that lets a client program specify a set of messages, based on the values of message headers and properties. A selector matches a message if, after substituting header and property values from the message into the selector string, the string evaluates to true. Consumers ..."},"891":{y:0,u:"../c-and-cobol-reference/identifiers.htm",l:-1,t:"Identifiers",i:0.000324877663273029,a:"Identifiers can refer to the values of message headers and properties, but not to the message body. Identifiers are case-sensitive. \n   Basic Syntax An identifier is a sequence of letters and digits, of any length, that begins with a letter. As in Java, the set of letters includes _ (underscore) and ..."},"892":{y:0,u:"../c-and-cobol-reference/literals.htm",l:-1,t:"Literals",i:0.000227983329142783,a:"String Literal \n\t\t\t  A string literal is enclosed in single quotes. To represent a single quote within a literal, use two single quotes; for example, \n\t\t\t\t\u0027literal\u0027\u0027s\u0027. String literals use the Unicode character encoding. String literals are case sensitive. \n\t\t\t  Exact Numeric Literal \n\t\t\t  An exact ..."},"893":{y:0,u:"../c-and-cobol-reference/expressions.htm",l:-1,t:"Expressions",i:0.000227983329142783,a:"Selectors as Expressions Every selector is a conditional expression. A selector that evaluates to true matches the message; a selector that evaluates to false or unknown does not match. \n\t\t\t  Arithmetic Expression Arithmetic expressions are composed of numeric literals, identifiers (that evaluate to ..."},"894":{y:0,u:"../c-and-cobol-reference/operators.htm",l:-1,t:"Operators",i:0.000227983329142783,a:"Case Insensitivity Operator names are not case-sensitive. \n\t\t\t  Logical Operators \n\t\t\t  Logical operators in precedence order: \n\t\t\t\tNOT, \n\t\t\t\tAND, \n\t\t\t\tOR. \n\t\t\t  Comparison Operators \n\t\t\t  Comparison operators: =, \u003e, \u003e=, \u003c, \u003c=, \u003c\u003e (not equal). \n\t\t\t  These operators can compare only values of ..."},"895":{y:0,u:"../c-and-cobol-reference/white-space.htm",l:-1,t:"White Space",i:0.000227983329142783,a:"White Space White space is any of the characters space, horizontal tab, form feed, or line terminator—or any contiguous run of characters in this set.\n  "},"896":{y:0,u:"../c-and-cobol-reference/data-type-conversion.htm",l:-1,t:"Data Type Conversion",i:0.000227983329142783,a:"The following table summarizes legal datatype conversions. The symbol X in indicates that a value written into a message as the row type can be extracted as the column type. This table applies to all message values—including map pairs, headers and properties—except as noted below. \n   Notes Message ..."},"897":{y:0,u:"../c-and-cobol-reference/tibemsmsg.htm",l:-1,t:"tibemsMsg",i:0.0199178645395032,a:"Type Purpose Messages that carry information among EMS client programs. \n\t\t Related Types tibemsBytesMsg, \n\t\t   tibemsMapMsg, \n\t\t   tibemsObjectMsg, \n\t\t   tibemsStreamMsg, \n\t\t   tibemsTextMsg Message Constants Constant \n\t\t\t\t Description \n\t\t\t\t TIBEMS_DEFAULT_DELIVERY_MODE TIBEMS_PERSISTENT When ..."},"898":{y:0,u:"../c-and-cobol-reference/tibemsmsg-acknowledg.htm",l:-1,t:"tibemsMsg_Acknowledge",i:0.00103897707238809,a:"Function Purpose Acknowledge messages. \n\t\t C Declaration tibems_status  tibemsMsg_Acknowledge(\n     tibemsMsg  message ); COBOL Call CALL \"tibemsMsg_Acknowledge\"\n     USING BY VALUE message,\n           RETURNING tibems-status\nEND-CALL. message has usage pointer. \n\t\t Parameters Remarks The behavior ..."},"899":{y:0,u:"../c-and-cobol-reference/tibemsmsg-clearbody.htm",l:-1,t:"tibemsMsg_ClearBody",i:0.00114193697106389,a:"Function Purpose Clear the body of a message. \n\t\t C Declaration tibems_status  tibemsMsg_ClearBody(\n     tibemsMsg  message ); COBOL Call CALL \"tibemsMsg_ClearBody\"\n     USING BY VALUE message,\n           RETURNING tibems-status\nEND-CALL. message has usage pointer. \n\t\t Parameters Remarks Clearing ..."},"900":{y:0,u:"../c-and-cobol-reference/tibemsmsg-clearprope.htm",l:-1,t:"tibemsMsg_ClearProperties",i:0.00067040472083971,a:"Function Purpose Clear the properties of a message. \n\t\t C Declaration tibems_status  tibemsMsg_ClearProperties(\n     tibemsMsg  message ); COBOL Call CALL \"tibemsMsg_ClearProperties\"\n     USING BY VALUE message,\n           RETURNING tibems-status\nEND-CALL. message has usage pointer. \n\t\t Parameters ..."},"901":{y:0,u:"../c-and-cobol-reference/tibemsmsg-create.htm",l:-1,t:"tibemsMsg_Create",i:0.00144624362156387,a:"Function Purpose Create a message object. \n\t\t C Declaration tibems_status  tibemsMsg_Create(\n     tibemsMsg * message ); COBOL Call CALL \"tibemsMsg_Create\"\n     USING BY REFERENCE message,\n           RETURNING tibems-status\nEND-CALL. message has usage pointer. \n\t\t Parameters Remarks Create a new ..."},"902":{y:0,u:"../c-and-cobol-reference/tibemsmsg-createcopy.htm",l:-1,t:"tibemsMsg_CreateCopy",i:0.000573510386709464,a:"Function Purpose Create a copy of the message object. \n\t\t C Declaration tibems_status  tibemsMsg_CreateCopy(\n    const  tibemsMsg  message,\n     tibemsMsg * copy ); COBOL Call CALL \"tibemsMsg_CreateCopy\"\n     USING BY VALUE message,\n           BY REFERENCE copy,\n           RETURNING ..."},"903":{y:0,u:"../c-and-cobol-reference/tibemsmsg-createfrom.htm",l:-1,t:"tibemsMsg_CreateFromBytes",i:0.000830828381575034,a:"Function Purpose Create a message object from data in a byte sequence. \n\t\t C Declaration tibems_status  tibemsMsg_CreateFromBytes(\n     tibemsMsg * message,\n    const void* bytes ); COBOL Call CALL \"tibemsMsg_CreateFromBytes\"\n     USING BY REFERENCE message,\n           BY REFERENCE bytes,\n           ..."},"904":{y:0,u:"../c-and-cobol-reference/tibemsmsg-destroy.htm",l:-1,t:"tibemsMsg_Destroy",i:0.00202072835304538,a:"tibemsMsg_Destroy Function Purpose Destroy a message. \n\t\t C Declaration tibems_status  tibemsMsg_Destroy(\n     tibemsMsg  message ); COBOL Call CALL \"tibemsMsg_Destroy\"\n     USING BY VALUE message,\n           RETURNING tibems-status\nEND-CALL. message has usage pointer. \n\t\t Parameters"},"905":{y:0,u:"../c-and-cobol-reference/tibemsmsg-getasbytes.htm",l:-1,t:"tibemsMsg_GetAsBytes",i:0.000830828381575034,a:"Function Purpose Get a byte sequence representation of the message object. \n\t\t C Declaration tibems_status  tibemsMsg_GetAsBytes(\n    const  tibemsMsg  message,\n    const void** bytes,\n     tibems_int * actual_size ); COBOL Call CALL \"tibemsMsg_GetAsBytes\"\n     USING BY VALUE message,\n           BY ..."},"906":{y:0,u:"../c-and-cobol-reference/tibemsmsg-getasbytes2.htm",l:-1,t:"tibemsMsg_GetAsBytesCopy",i:0.000985475881209281,a:"Function Purpose Copy a byte sequence representation of the message object into storage supplied by the program. \n\t\t C Declaration tibems_status  tibemsMsg_GetAsBytesCopy(\n    const  tibemsMsg  message,\n    const void* bytes,\n     tibems_int  avail_size,\n     tibems_int * actual_size ); COBOL Call ..."},"907":{y:0,u:"../c-and-cobol-reference/tibemsmsg-getbodytyp.htm",l:-1,t:"tibemsMsg_GetBodyType",i:0.00153048177081486,a:"Function Purpose Get the body type of a message. \n\t\t \n                Message body type is distinct from message type—even though they have similar names. Contrast \n\t\t   tibemsMsg_GetType. \n\t\t C Declaration tibems_status  tibemsMsg_GetBodyType(\n     tibemsMsg  message,\n     tibemsMsgType * type ); ..."},"908":{y:0,u:"../c-and-cobol-reference/tibemsmsg-getbytesiz.htm",l:-1,t:"tibemsMsg_GetByteSize",i:0.000830828381575034,a:"Function Purpose Compute the size of the byte sequence representation of the message. \n\t\t C Declaration tibems_status  tibemsMsg_GetByteSize(\n     tibemsMsg  message,\n     tibems_int * size ); COBOL Call CALL \"tibemsMsg_GetByteSize\"\n     USING BY VALUE message,\n           BY REFERENCE size,\n         ..."},});